Begin Declaration {


Create Class Course 
Tuple(
	name 		String[20],
	number 		String[12],
        sections 	LIST(Section),
        has_prereq     SET(Course),
        is_prereq_for  SET(Course)

)

Create Class Section
Tuple(
	number		String[20],
        taught_by       Ref(Professor) 
)

Create Class Employee
Tuple(
	id		Integer,
	name		String[32],
	age		Integer,	
	salary		Integer
)


Create Class Professor inherits from Employee 
Tuple(
	enum    	String[20],
	rank	        String[20]	,
	teaches         Set(Section)	
)

Create Class Student
Tuple(
	name		String[20],
        student_id      String[10],
        dorm_address    Dorm,
        takes           Set(Section)

)

Create Class TA inherits from Employee, Student
Tuple(
	assigned_to    Ref(Professor) 
)

Create Class Person 
Tuple(
	name	String[30],
        age     Integer
)


Create Type Dorm
Tuple(
         college      String[30],
         room_no      String[20]

)
};
