#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <memory.h>
#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "dld.h"
#include "mood_alg.h"

void *InpArr[15];

char *ExecuteTerm(ExecStruct *Head) {

      if (Head->Left) {
         ExecuteTerm(Head->Left);
      }
      Head->ExecFunc(Head);
      if (Head->ExecRight && Head->Right) {
         ExecuteTerm(Head->Right);
         Head->ExecFunc(Head);
      }
      return(Head->Result);
}

  void NullFunc(ExecStruct *Res) {
  }

  void  AddInt(ExecStruct *Res) { 
      *((int *)Res->Result) = *((int *)(Res->Left->Result)) + *((int *)(Res->Right->Result));
  }
  void  AddChar(ExecStruct *Res) { 
      *((char *)Res->Result) = *((char *)(Res->Left->Result)) + *((char *)(Res->Right->Result));
  }
  void  AddIntReal(ExecStruct *Res) { 
      *((float *)Res->Result) = *((int *)(Res->Left->Result)) + *((float *)(Res->Right->Result));
  }
  void  AddCharReal(ExecStruct *Res) { 
      *((float *)Res->Result) = *((char *)(Res->Left->Result)) + *((float *)(Res->Right->Result));
  }
  void  AddIntChar(ExecStruct *Res) { 
      *((int *)Res->Result) = *((int *)(Res->Left->Result)) + *((char *)(Res->Right->Result));
  }
  void  AddCharInt(ExecStruct *Res) { 
      *((int *)Res->Result) = *((char *)(Res->Left->Result)) + *((int *)(Res->Right->Result));
  }
  void AddReal(ExecStruct *Res) { 
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) + *((float *)(Res->Right->Result));
  }
  void AddRealInt(ExecStruct *Res) { 
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) + *((int *)(Res->Right->Result));
  }
  void AddRealChar(ExecStruct *Res) { 
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) + *((char *)(Res->Right->Result));
  }
  void  SubInt(ExecStruct *Res) { 
      *((int *)Res->Result) = *((int *)(Res->Left->Result)) - *((int *)(Res->Right->Result));
  }
  void  SubChar(ExecStruct *Res) { 
      *((char *)Res->Result) = *((char *)(Res->Left->Result)) - *((char *)(Res->Right->Result));
  }
  void  SubIntReal(ExecStruct *Res) { 
      *((float *)Res->Result) = *((int *)(Res->Left->Result)) - *((float *)(Res->Right->Result));
  }
  void  SubCharReal(ExecStruct *Res) { 
      *((float *)Res->Result) = *((char *)(Res->Left->Result)) - *((float *)(Res->Right->Result));
  }
  void  SubIntChar(ExecStruct *Res) { 
      *((int *)Res->Result) = *((int *)(Res->Left->Result)) - *((char *)(Res->Right->Result));
  }
  void  SubCharInt(ExecStruct *Res) { 
      *((int *)Res->Result) = *((char *)(Res->Left->Result)) - *((char *)(Res->Right->Result));
  }
  void  SubReal(ExecStruct *Res) { 
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) - *((float *)(Res->Right->Result));
  }
  void  SubRealInt(ExecStruct *Res) { 
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) - *((int *)(Res->Right->Result));
  }
  void  SubRealChar(ExecStruct *Res) { 
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) - *((char *)(Res->Right->Result));
  }

  void DivInt(ExecStruct *Res) {
      *((int *)Res->Result) = *((int *)(Res->Left->Result)) / *((int *)(Res->Right->Result));
  }
  void DivChar(ExecStruct *Res) {
      *((char *)Res->Result) = *((char *)(Res->Left->Result)) / *((char *)(Res->Right->Result));
  }

  void DivIntReal(ExecStruct *Res) {
      *((float *)Res->Result) = *((int *)(Res->Left->Result)) / *((float *)(Res->Right->Result));
  }

  void DivIntChar(ExecStruct *Res) {
      *((int *)Res->Result) = *((int *)(Res->Left->Result)) / *((char *)(Res->Right->Result));
  }

  void DivCharInt(ExecStruct *Res) {
      *((int *)Res->Result) = *((char *)(Res->Left->Result)) / *((int *)(Res->Right->Result));
  }
  void DivReal(ExecStruct *Res) {
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) / *((float *)(Res->Right->Result));
  }

  void DivRealInt(ExecStruct *Res) {
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) / *((int *)(Res->Right->Result));
  }

  void DivRealChar(ExecStruct *Res) {
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) / *((char *)(Res->Right->Result));
  }

  void DivCharReal(ExecStruct *Res) {
      *((float *)Res->Result) = *((char *)(Res->Left->Result)) / *((float *)(Res->Right->Result));
  }

  void MultInt(ExecStruct *Res) {
      *((int *)Res->Result) = *((int *)(Res->Left->Result)) * *((int *)(Res->Right->Result));
  }

  void MultChar(ExecStruct *Res) {
      *((char *)Res->Result) = *((char *)(Res->Left->Result)) * *((char *)(Res->Right->Result));
  }

  void MultIntReal(ExecStruct *Res) {
      *((float *)Res->Result) = *((int *)(Res->Left->Result)) * *((float *)(Res->Right->Result));
  }

  void MultIntChar(ExecStruct *Res) {
      *((int *)Res->Result) = *((int *)(Res->Left->Result)) * *((char *)(Res->Right->Result));
  }

  void MultCharInt(ExecStruct *Res) {
      *((int *)Res->Result) = *((char *)(Res->Left->Result)) * *((int *)(Res->Right->Result));
  }

  void MultReal(ExecStruct *Res) {
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) * *((float *)(Res->Right->Result));
  }

  void MultRealInt(ExecStruct *Res) {
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) * *((int *)(Res->Right->Result));
  }

  void MultRealChar(ExecStruct *Res) {
      *((float *)Res->Result) = *((float *)(Res->Left->Result)) * *((char *)(Res->Right->Result));
  }

  void MultCharReal(ExecStruct *Res) {
      *((float *)Res->Result) = *((char *)(Res->Left->Result)) * *((float *)(Res->Right->Result));
  }

  void InputFunc1(ExecStruct *Res) {
      char *p;
      int q;
      p = (char *)(InpArr[0]+Res->Op_Inp.Attr_Inp.attr_offset);
      q = Res->Op_Inp.Attr_Inp.attr_len; 
      memcpy(Res->Result,(void *)p,q);
  }

  void InputFunc2(ExecStruct *Res) {
      char *p;
      int q;
      p = (char *)(InpArr[1]+Res->Op_Inp.Attr_Inp.attr_offset);
      q = Res->Op_Inp.Attr_Inp.attr_len; 
      memcpy(Res->Result,(void *)((int)InpArr[1]+Res->Op_Inp.Attr_Inp.attr_offset),Res->Op_Inp.Attr_Inp.attr_len);
  }

  void InputFunc3(ExecStruct *Res) {
      memcpy(Res->Result,(void *)((int)InpArr[2]+Res->Op_Inp.Attr_Inp.attr_offset),Res->Op_Inp.Attr_Inp.attr_len);
  }

  void InputFunc4(ExecStruct *Res) {
      memcpy(Res->Result,(void *)((int)InpArr[3]+Res->Op_Inp.Attr_Inp.attr_offset),Res->Op_Inp.Attr_Inp.attr_len);
  }

  void ExecFunc1(ExecStruct *Res) {
   int i;
   void *retptr;

      Res->Op_Inp.Fcn_Inp.ParBuf->ResetParNum();
      Res->Op_Inp.Fcn_Inp.ParBuf->add_parameters(InpArr[0]+Res->Op_Inp.Fcn_Inp.offset);
      for(i=0; i< Res->Op_Inp.Fcn_Inp.argnum; ++i) {
         ExecuteTerm(Res->Op_Inp.Fcn_Inp.Args[i]);
         Res->Op_Inp.Fcn_Inp.ParBuf->add_parameters((void *)(Res->Op_Inp.Fcn_Inp.Args[i]->Result));
      }
      retptr = Res->Op_Inp.Fcn_Inp.FcnInfo->execute(Res->Op_Inp.Fcn_Inp.ParBuf);
      if (Res->operand_type == TEXT)
         memcpy(Res->Result,*(void **)retptr,sizeof(CONSTANT));
      else
         memcpy(Res->Result,retptr,sizeof(CONSTANT));
  }

  void ExecFunc2(ExecStruct *Res) {
   int i;
   void *retptr;

      Res->Op_Inp.Fcn_Inp.ParBuf->ResetParNum();
      Res->Op_Inp.Fcn_Inp.ParBuf->add_parameters(InpArr[1]+Res->Op_Inp.Fcn_Inp.offset);
      for(i=0; i< Res->Op_Inp.Fcn_Inp.argnum; ++i) {
         ExecuteTerm(Res->Op_Inp.Fcn_Inp.Args[i]);
         Res->Op_Inp.Fcn_Inp.ParBuf->add_parameters((void *)(Res->Op_Inp.Fcn_Inp.Args[i]->Result));
      }
      retptr = Res->Op_Inp.Fcn_Inp.FcnInfo->execute(Res->Op_Inp.Fcn_Inp.ParBuf);
      if (Res->operand_type == TEXT)
         memcpy(Res->Result,*(void **)retptr,sizeof(CONSTANT));
      else
         memcpy(Res->Result,retptr,sizeof(CONSTANT));
  }

  void ExecFunc3(ExecStruct *Res) {
   int i;
   void *retptr;

      Res->Op_Inp.Fcn_Inp.ParBuf->ResetParNum();
      Res->Op_Inp.Fcn_Inp.ParBuf->add_parameters(InpArr[2]+Res->Op_Inp.Fcn_Inp.offset);
      for(i=0; i< Res->Op_Inp.Fcn_Inp.argnum; ++i) {
         ExecuteTerm(Res->Op_Inp.Fcn_Inp.Args[i]);
         Res->Op_Inp.Fcn_Inp.ParBuf->add_parameters((void *)(Res->Op_Inp.Fcn_Inp.Args[i]->Result));
      }
      retptr = Res->Op_Inp.Fcn_Inp.FcnInfo->execute(Res->Op_Inp.Fcn_Inp.ParBuf);
      if (Res->operand_type == TEXT)
         memcpy(Res->Result,*(void **)retptr,sizeof(CONSTANT));
      else
         memcpy(Res->Result,retptr,sizeof(CONSTANT));
  }

  void ExecFunc4(ExecStruct *Res) {
   int i;
   void *retptr;

      Res->Op_Inp.Fcn_Inp.ParBuf->ResetParNum();
      Res->Op_Inp.Fcn_Inp.ParBuf->add_parameters(InpArr[3] + Res->Op_Inp.Fcn_Inp.offset);
      for(i=0; i< Res->Op_Inp.Fcn_Inp.argnum; ++i) {
         ExecuteTerm(Res->Op_Inp.Fcn_Inp.Args[i]);
         Res->Op_Inp.Fcn_Inp.ParBuf->add_parameters((void *)(Res->Op_Inp.Fcn_Inp.Args[i]->Result));
      }
      retptr = Res->Op_Inp.Fcn_Inp.FcnInfo->execute(Res->Op_Inp.Fcn_Inp.ParBuf);
      if (Res->operand_type == TEXT)
         memcpy(Res->Result,*(void **)retptr,sizeof(CONSTANT));
      else
         memcpy(Res->Result,retptr,sizeof(CONSTANT));
  }

  void LessInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result < *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }
     
  void LessIntReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result < *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }
     
  void LessIntChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result < *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }
     
  void GreaterInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result > *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterIntReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result > *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterIntChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result > *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result == *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualIntReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result == *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualIntChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result == *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result != *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualIntReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result != *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualIntChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result != *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result <= *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualIntReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result <= *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualIntChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result <= *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result >= *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualIntReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result >= *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualIntChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(int *)Res->Left->Result >= *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void AddStr(ExecStruct *Res) { 
  }

  void SubStr(ExecStruct *Res) {
  }

  void LessStr(ExecStruct *Res) {
  }
     
  void GreaterStr(ExecStruct *Res) {
     if (Res->First) {
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualStr(ExecStruct *Res) {
     if (Res->First) {
        if (strcmp(Res->Left->Result,Res->Right->Result))
           Res->Result[0] = 0;
        else
           Res->Result[0] = 1;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualStr(ExecStruct *Res) {
     if (Res->First) {
        if (strcmp(Res->Left->Result,Res->Right->Result))
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualStr(ExecStruct *Res) {
     if (Res->First) {
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualStr(ExecStruct *Res) {
     if (Res->First) {
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result < *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }
     
  void LessRealInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result < *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }
     
  void LessRealChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result < *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }
     
  void GreaterReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result > *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterRealInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result > *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterRealChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result > *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result == *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualRealInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result == *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualRealChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result == *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result != *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualRealInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result != *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualRealChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result != *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result <= *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualRealInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result <= *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualRealChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result <= *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result >= *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualRealInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result >= *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualRealChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(float *)Res->Left->Result >= *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result < *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }
     
  void LessCharInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result < *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }
     
  void LessCharReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result < *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }
     
  void GreaterChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result > *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterCharInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result > *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterCharReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result > *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result == *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualCharInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result == *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void EqualCharReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result == *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result != *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualCharInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result != *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void NotEqualCharReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result != *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result <= *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualCharInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result <= *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void LessOrEqualCharReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result <= *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualChar(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result >= *(char *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualCharInt(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result >= *(int *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void GreaterOrEqualCharReal(ExecStruct *Res) {
     if (Res->First) {
        if (*(char *)Res->Left->Result >= *(float *)Res->Right->Result)
           Res->Result[0] = 1;
        else
           Res->Result[0] = 0;
        Res->First = 0;
     }
     else
        Res->First = 1;
  }

  void AndOp(ExecStruct *Res) {
     if (!Res->First) {
        if (Res->Left->Result[0]) {
           Res->First = 1;
           Res->ExecRight = 1;
        }
        else {
           Res->Result[0] = 0;
           Res->ExecRight = 0;
        }
     }
     else {
        Res->Result[0] = Res->Right->Result[0];
        Res->First = 0;
     }
  }

  void OrOp(ExecStruct *Res) {
     if (!Res->First) {
        if (!Res->Left->Result[0]) {
           Res->First = 1;
           Res->ExecRight = 1;
        }
        else {
           Res->Result[0] = 1;
           Res->ExecRight = 0;
        }
     }
     else {
        Res->Result[0] = Res->Right->Result[0];
        Res->First = 0;
     }
  }

  void EqualRef(ExecStruct *Res) {
     if (Res->First) {
        if (memcmp(Res->Left->Result,Res->Right->Result,12))
           Res->Result[0] = 0;
        else
           Res->Result[0] = 1;
           Res->First = 0;
     }
     else
        Res->First = 1;
  }


void DeletePar(char *AttrName) {
 char *LeftPar, *RightPar;
 for(LeftPar=strchr(AttrName,'(');LeftPar;LeftPar=strchr(AttrName,'(')) {
    RightPar = strchr(AttrName,')');
    strcpy((char *)(LeftPar+1),RightPar);
    AttrName = RightPar+1;
 } 
}


ExecStruct *ConvertNewForm(EXPR_TYPE *Head, PLAN *Self) {
  ExecStruct *pleft, *pright;
  ExecStruct *p = new ExecStruct;
     
     if (Head->left) {
        pleft = ConvertNewForm(Head->left,Self);
        if (!pleft)
           return NULL;
     }
     else
        pleft = NULL;
     if (Head->right) { 
        pright = ConvertNewForm(Head->right,Self);
        if (!pright)
           return NULL;
     }
     else
        pright = NULL;

     p->Left = pleft;
     p->Right = pright;

     switch(Head->type) {
     case ATTRIB : {
                   if (Self) {
                      PLAN *q = Self;
                      ATTRIBUTE *attr_info=NULL;
                      char AttrName[MAX_ATTR_NAME_LEN];
                      // int selfoff;

                      strcpy(AttrName,Head->data.attr);
                      DeletePar(AttrName);
                      for(int i=0;q->input[i];++i) {
                         for(int k=0;k<q->input[i]->logical_property.arity;++k) {
                            if (!strcmp(AttrName,q->input[i]->logical_property.attr[k]->name)) {
                                attr_info = q->input[i]->logical_property.attr[k];
                                break;
                            }
                          }
                          if (attr_info)
                             break;
                      }
                      if (!attr_info)
                         return NULL;
                      if (attr_info->attr_type == METHOD) {
                         if (i==0) p->ExecFunc = ExecFunc1;
                         else if (i == 1) p->ExecFunc = ExecFunc2;
                         else if (i == 2) p->ExecFunc = ExecFunc3;
                         else if (i == 3) p->ExecFunc = ExecFunc4;
                         p->method = 1;
                         p->operand_type = Head->fcn->ret_type;
                         /* dynamic Linking ile ilgili kisim burada olacak 
                            ve her bir ExecFunc icin ayri bir Function class
                            variable tanimlanacak ! */

                         p->Op_Inp.Fcn_Inp.argnum = Head->fcn->argnum;
                         p->Op_Inp.Fcn_Inp.offset = attr_info->offset;
                         strcpy(p->Op_Inp.Fcn_Inp.Fname,Head->fcn->FcnName);
                         p->Op_Inp.Fcn_Inp.ParBuf = new Params(Head->fcn->argnum+1);
                         p->Op_Inp.Fcn_Inp.FcnInfo = new Function(Head->data.attr);
                         for(i=0;i<Head->fcn->argnum;++i) {
                            if (!(p->Op_Inp.Fcn_Inp.Args[i] = ConvertNewForm(Head->fcn->ParExpr[i],NULL)))
                               return NULL;
                         }
                         
                      }
                      else if (attr_info->attr_type == DB_TYPE) {
                         p->operand_type = DB_TYPE;
                         p->Op_Inp.Attr_Inp.attr_offset = attr_info->offset;
                         p->ExecFunc = NullFunc;
                      }
                      else {
                         if (i==0) p->ExecFunc = InputFunc1;
                         else if (i == 1) p->ExecFunc = InputFunc2;
                         else if (i == 2) p->ExecFunc = InputFunc3;
                         else if (i == 3) p->ExecFunc = InputFunc4;
                         p->operand_type = attr_info->attr_type;
                         p->Op_Inp.Attr_Inp.attr_len = attr_info->attr_width;
                         p->Op_Inp.Attr_Inp.attr_offset = attr_info->offset;
                      }
                   } /* IF */

                   break;
                   }

     case OPER : switch(Head->data.op) {
                 case EQUAL_OP : 
                                 switch(p->Left->operand_type) {
                                     case INTEGER :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = EqualIntReal;
                                                     break;
                                             case MS_BOOLEAN :
                                             case CHAR :
                                                     p->ExecFunc = EqualIntChar;
                                                     break;
                                             default :
                                                     p->ExecFunc = EqualInt;
                                                     break;
                                            }
                                            break;
                                     case REAL : 
                                           switch(p->Right->operand_type) {
                                             case INTEGER : 
                                                     p->ExecFunc = EqualRealInt;
                                                     break;
                                             case CHAR :
                                                     p->ExecFunc = EqualRealChar;
                                                     break;
                                             default :
                                                     p->ExecFunc = EqualReal;
                                                     break;
                                            }
                                            break;
                                     case TEXT : p->ExecFunc = EqualStr;
                                                 break;
                                     case SET :
                                     case LIST :
                                     case REF  : p->ExecFunc = EqualRef;
                                                 break;
                                     case MS_BOOLEAN :
                                     case CHAR : 
                                           switch(p->Right->operand_type) {
                                             case INTEGER : 
                                                     p->ExecFunc = EqualCharInt;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = EqualCharReal;
                                                     break;
                                             default :
                                                     p->ExecFunc = EqualChar;
                                                     break;
                                            }
                                            break;
                                 }
                                 break;
                 case LESS_THAN_OP :  
                                 switch(p->Left->operand_type) {
                                     case INTEGER : 
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = LessIntChar;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = LessIntReal;
                                                     break;
                                             default :
                                                     p->ExecFunc = LessInt;
                                                     break;
                                            }
                                            break;
                                     case REAL :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = LessRealChar;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = LessRealInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = LessReal;
                                                     break;
                                            }
                                            break;
                                     case TEXT : p->ExecFunc = LessStr;
                                                 break;
                                     case CHAR :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = LessCharReal;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = LessCharInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = LessChar;
                                                     break;
                                            }
                                            break;
                                 }
                                     break;
                 case GREATER_THAN_OP : 
                                 switch(p->Left->operand_type) {
                                     case INTEGER :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = GreaterIntChar;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = GreaterIntReal;
                                                     break;
                                             default :
                                                     p->ExecFunc = GreaterInt;
                                                     break;
                                            }
                                            break;
                                     case REAL : 
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = GreaterRealChar;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = GreaterRealInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = GreaterReal;
                                                     break;
                                            }
                                            break;
                                     case CHAR :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = GreaterCharReal;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = GreaterCharInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = GreaterChar;
                                                     break;
                                            }
                                            break;
                                     case TEXT : p->ExecFunc = GreaterStr;
                                                 break;
                                 }
                                        break;
                 case LESS_THAN_EQUAL_OP : 
                                 switch(p->Left->operand_type) {
                                     case INTEGER : 
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = LessOrEqualIntChar;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = LessOrEqualIntReal;
                                                     break;
                                             default :
                                                     p->ExecFunc = LessOrEqualInt;
                                                     break;
                                            }
                                            break;
                                     case REAL : 
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = LessOrEqualRealChar;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = LessOrEqualRealInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = LessOrEqualReal;
                                                     break;
                                            }
                                            break;
                                     case CHAR :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = LessOrEqualCharReal;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = LessOrEqualCharInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = LessOrEqualChar;
                                                     break;
                                            }
                                            break;
                                     case TEXT : p->ExecFunc = LessOrEqualStr;
                                                 break;
                                 }
                                           break;
                 case GREATER_THAN_EQUAL_OP :
                                 switch(p->Left->operand_type) {
                                     case INTEGER :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = GreaterOrEqualIntChar;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = GreaterOrEqualIntReal;
                                                     break;
                                             default :
                                                     p->ExecFunc = GreaterOrEqualInt;
                                                     break;
                                            }
                                            break;
                                     case REAL :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = GreaterOrEqualRealChar;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = GreaterOrEqualRealInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = GreaterOrEqualReal;
                                                     break;
                                            }
                                            break;
                                     case CHAR :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = GreaterOrEqualCharReal;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = GreaterOrEqualCharInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = GreaterOrEqualChar;
                                                     break;
                                            }
                                            break;
                                     case TEXT : p->ExecFunc = GreaterOrEqualStr;
                                                 break;
                                 }
                                              break;
                 case NOT_EQUAL_OP :
                                 switch(p->Left->operand_type) {
                                     case INTEGER : 
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = NotEqualIntChar;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = NotEqualIntReal;
                                                     break;
                                             default :
                                                     p->ExecFunc = NotEqualInt;
                                                     break;
                                            }
                                            break;
                                     case REAL :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = NotEqualRealChar;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = NotEqualRealInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = NotEqualReal;
                                                     break;
                                            }
                                            break;
                                     case CHAR :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = NotEqualCharReal;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = NotEqualCharInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = NotEqualChar;
                                                     break;
                                            }
                                            break;
                                     case TEXT : p->ExecFunc = NotEqualStr;
                                                 break;
                                 }
                                 break;
                  case PLUS : 
                  case ADD  :
                                 switch(p->Left->operand_type) {
                                     case INTEGER :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = AddIntChar;
                                                     p->operand_type = INTEGER;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = AddIntReal;
                                                     p->operand_type = REAL;
                                                     break;
                                             default :
                                                     p->ExecFunc = AddInt;
                                                     p->operand_type = INTEGER;
                                                     break;
                                            }
                                            break;
                                     case REAL :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = AddRealChar;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = AddRealInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = AddReal;
                                                     break;
                                            }
                                            p->operand_type = REAL;
                                            break;
                                     case CHAR :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = AddCharReal;
                                                     p->operand_type = REAL;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = AddCharInt;
                                                     p->operand_type = INTEGER;
                                                     break;
                                             default :
                                                     p->ExecFunc = AddChar;
                                                     p->operand_type = CHAR;
                                                     break;
                                            }
                                            break;
                                     case TEXT : p->ExecFunc = AddStr;
                                                 p->operand_type = TEXT;
                                                 break;
                                 }
                                 break;
                   case SUB :
                                 switch(p->Left->operand_type) {
                                     case INTEGER :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = SubIntChar;
                                                     p->operand_type = INTEGER;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = SubIntReal;
                                                     p->operand_type = REAL;
                                                     break;
                                             default :
                                                     p->ExecFunc = SubInt;
                                                     p->operand_type = INTEGER;
                                                     break;
                                            }
                                            break;
                                     case REAL :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = SubRealChar;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = SubRealInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = SubReal;
                                                     break;
                                            }
                                            p->operand_type = REAL;
                                            break;
                                     case CHAR :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = SubCharReal;
                                                     p->operand_type = REAL;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = SubCharInt;
                                                     p->operand_type = INTEGER;
                                                     break;
                                             default :
                                                     p->ExecFunc = SubChar;
                                                     p->operand_type = CHAR;
                                                     break;
                                            }
                                            break;
                                     case TEXT : p->ExecFunc = SubStr;
                                                 p->operand_type = TEXT;
                                                 break;
                                 }
                                 break;
                     case MUL :
                                 switch(p->Left->operand_type) {
                                     case INTEGER :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = MultIntChar;
                                                     p->operand_type = INTEGER;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = MultIntReal;
                                                     p->operand_type = REAL;
                                                     break;
                                             default :
                                                     p->ExecFunc = MultInt;
                                                     p->operand_type = INTEGER;
                                                     break;
                                            }
                                            break;
                                     case REAL : p->ExecFunc = MultReal;
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = MultRealChar;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = MultRealInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = MultReal;
                                                     break;
                                            }
                                            p->operand_type = REAL;
                                            break;
                                     case CHAR :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = MultCharReal;
                                                     p->operand_type = REAL;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = MultCharInt;
                                                     p->operand_type = INTEGER;
                                                     break;
                                             default :
                                                     p->ExecFunc = MultChar;
                                                     p->operand_type = CHAR;
                                                     break;
                                            }
                                            break;
                                 }
                                 break;
                      case DIV : 
                                 switch(p->Left->operand_type) {
                                     case INTEGER :
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = DivIntChar;
                                                     p->operand_type = INTEGER;
                                                     break;
                                             case REAL :
                                                     p->ExecFunc = DivIntReal;
                                                     p->operand_type = REAL;
                                                     break;
                                             default :
                                                     p->ExecFunc = DivInt;
                                                     p->operand_type = INTEGER;
                                                     break;
                                            }
                                            break;
                                     case REAL : 
                                           switch(p->Right->operand_type) {
                                             case CHAR : 
                                                     p->ExecFunc = DivRealChar;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = DivRealInt;
                                                     break;
                                             default :
                                                     p->ExecFunc = DivReal;
                                                     break;
                                            }
                                            p->operand_type = REAL;
                                            break;
                                     case CHAR :
                                           switch(p->Right->operand_type) {
                                             case REAL : 
                                                     p->ExecFunc = DivCharReal;
                                                     p->operand_type = REAL;
                                                     break;
                                             case INTEGER :
                                                     p->ExecFunc = DivCharInt;
                                                     p->operand_type = INTEGER;
                                                     break;
                                             default :
                                                     p->ExecFunc = DivChar;
                                                     p->operand_type = CHAR;
                                                     break;
                                            }
                                            break;
                                 }
                                 break;
                       case AND_OP :
                                 p->ExecFunc = AndOp;
                                 break;
                       case OR_OP :
                                 p->ExecFunc = OrOp;
                                 break;
                       case NO_OP :
                                 break;
                      }
                      break;
        case CONST : memcpy(p->Result,(char *)&((Head->data).cnst).value,sizeof(CONSTANT));
                     p->operand_type = Head->data.cnst.kind; 
                     p->ExecFunc = NullFunc;
                     break;
        }
                   
        return p;
 }

ExecStruct *ConvertSelectExpr(SELECT_ARG *Head, PLAN *self) {
  int i;
  EXPR_TYPE *p, *q, *RetHead;
  
  q = NULL;
  for(i=0;i<Head->terms;++i) {
    p = (EXPR_TYPE *) malloc(sizeof(EXPR_TYPE));
    p->type = Head->cond[i]->type;
    p->data = Head->cond[i]->data;
    p->fcn = Head->cond[i]->fcn; 
    p->left = Head->cond[i]->left;
    p->right = Head->cond[i]->right;
    if (q) {
       RetHead = (EXPR_TYPE *) malloc(sizeof(EXPR_TYPE));
       RetHead->type = OPER;
       RetHead->data.op = Head->op[i-1];
       RetHead->left = q;
       RetHead->right = p;
       q = RetHead;
    }
    else {
       q = p;
       RetHead = q;
    }
  }
  return(ConvertNewForm(RetHead,self));
} 
