#include "libMv.h"

Widget BuildList(Widget parent,char *title,char *ite[],int  n)
{
    Widget label, list_w, rowcol;
    int i;
    XmStringTable    str_list;
    XmStringCharSet  charset; 

    rowcol = XtVaCreateWidget("rowcol", xmRowColumnWidgetClass,
        parent,
        XmNorientation, XmVERTICAL,
        NULL);

    label = XtVaCreateManagedWidget(title,
        xmLabelGadgetClass, rowcol,
        XmNrightAttachment,  XmATTACH_FORM,
        NULL);

    str_list = (XmStringTable)XtMalloc(n * sizeof (XmString *));
    for (i = 0; i < n; i++) {
        printf("Third: %s\n", ite[i]);
        str_list[i] = XmStringCreateLtoR(ite[i], charset);
    }
    list_w = XmCreateScrolledList(rowcol, "list", NULL, 0);
    XtVaSetValues(list_w,
      XmNitems,            str_list,
      XmNitemCount,        n,
      XmNvisibleItemCount, 4,
      XmNselectionPolicy,  XmEXTENDED_SELECT,
      NULL);
    XtManageChild(rowcol);

    for (i = 0; i < n; i++)
        XmStringFree(str_list[i]);
    XtFree((char *)str_list);
    return list_w;
}
