#ifndef __HASHTABLE_H
#define __HASHTABLE_H
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <sm_client.h>

struct OneRecord {
       OID loid;
       OID poid;
};

class Bucket {
   public :
         struct OneRecord *BucketRecords;
         int RecNum;
         Bucket *NextBucket;
         Bucket *OverFlowBucket;
         Bucket (int BF) { BucketRecords = new OneRecord[BF];
                           RecNum = 0;
                           NextBucket = NULL;
                           OverFlowBucket = NULL;
                         }
         ~Bucket() { delete BucketRecords; }
};

class LinHash {
   int BF;
   float LF;
   int BoundVal;
   int BitsUsed;
   int SplitNum;
   int SNum;
   int MaskNum;
   public:
         Bucket *HashBuckets;
         LinHash(int BucFac, float LoadFac);
         void InsertIntoHash(struct OneRecord InRec);
         Bucket *FindBucket(int EntNum);
         void PrintHashTable();
         ~LinHash();
};

#endif
