#include "sm_SortFile.h"
/* Field Types 
   The following field types can be modified without any other change.
   These values can be extracted Certan-Moods-Files
*/
#define ms_INT		0x100
#define ms_BOOL		0x200
#define ms_CHAR		0x300
#define ms_FLOAT	0x400
#define ms_OID		0x500
#define ms_STRING	0x600



/* type definitions 
*/


/* The following structure will be used for identifying and creating initial
   sorted segments.
*/

/* This structure is used to pass arguments to the join function 
*/

 typedef struct {
	FID  Fid;	/* File descriptor for join */	
	int FldOffset;  /* field offset in UserDesc->baseptr */
	int FldLen;     /* Field length */
	int FldType;    /* Field type   */
	int FldMask;    /* Field mask  - Certan */
	struct SegmentInfo * Segment; // Segment for the file 
	int NumofSegments; 	// number of segments for the file
        int ObjLen;
        void *CurrItem;
 } JoinFileInfo;



