#ifndef __SM_SORTFILE_H
#define __SM_SORTFILE_H
/* Constants */
#define UNIQUE 1
#define MAXNUMOFPAGES    20
#define LIMITEDPAGES     4
#define SEGMENTSIZE      1023 
#define MAXSEGMENTNUMBER 1000
#define SizeofOID        12

/* Type Definitions */
struct SegmentInfo {
  int HeapSize;
  int SegBgi;
  FID SegFid;
  BOOL EofReached;
  SCANDESC *SegSDesc;
  void *CurrItem;
  OID CurrOid;
};

/* External function prototype */
extern int sm_SortFile(int,int,FID,FID *,SMDATATYPE,int,int);
extern int PrepareKeyOidFile(int,int,FID,FID *,int,int,int *);
#endif
