/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/error_text.c,v 1.16 92/11/18 01:32:55 bill Exp Locker: bill $ 
*
*/ 
 
#include "opt_defs.h"
#include "global.h"

typedef int STATUS ;

#if defined(__cplusplus) || defined (ANSI)
char *error_text (STATUS error)
#else
char *error_text (error)
STATUS error ;
#endif
{
#if defined(__cplusplus) || defined (ANSI)
    extern char		*dbi_error_text (STATUS) ;
#else
    extern char         *dbi_error_text () ;
#endif
    switch (error)
    {
        case ERR_NULL_POINTER: 			return ("ERR_NULL_POINTER") ;
	case ERR_SANITY_CHECK: 			return ("ERR_SANITY_CHECK") ;
	case ERR_UNKNOWN_PROPERTY_VALUE: 	return ("ERR_UNKNOWN_PROPERTY_VALUE") ;
	case ERR_UNKNOWN_OPERATOR: 		return ("ERR_UNKNOWN_OPERATOR") ;
	case ERR_UNKNOWN_ALGORITHM: 		return ("ERR_UNKNOWN_ALGORITHM") ;
	case ERR_UNKNOWN_RULE_GROUP: 		return ("ERR_UNKNOWN_RULE_GROUP") ;
	case ERR_UNKNOWN_SET_ID: 		return ("ERR_UNKNOWN_SET_ID") ;
        case ERR_NOT_IMPLEMENTED: 		return ("ERR_NOT_IMPLEMENTED") ;
	case ERR_NOT_FOUND:  			return ("ERR_NOT_FOUND") ;
	case ERR_MEM_ALLOC_FAILED: 		return ("ERR_MEM_ALLOC_FAILED") ;
	case ERR_NOT_INITIALIZED: 		return ("ERR_NOT_INITIALIZED") ;
	case ERR_ALREADY_INITIALIZED: 		return ("ERR_ALREADY_INTIALIZED") ;
	case ERR_INDEX_OUT_OF_RANGE: 		return ("ERR_INDEX_OUT_OF_RANGE") ;
	case ERR_POINTER_PROBLEM: 		return ("ERR_POINTER_PROBLEM") ;
	case ERR_UNKNOWN_VALUE: 		return ("ERR_UNKNOWN_VALUE") ;
        case ERR_INVALID_VALUE: 		return ("ERR_INVALID_VALUE") ;
        case ERR_OPTIMIZER_FAILED: 		return ("ERR_OPTIMIZER_FAILED") ;
        case ERR_OPTIMIZER_INTERNAL_ERROR: 	return ("ERR_OPTIMIZER_INTERNAL_ERROR") ;
        case ERR_PROPERTIES_FILLED: 		return ("ERR_PROPERTIES_FILLED") ;
        default: 				return (dbi_error_text (error)) ;
    }
}
