/*ident	"%W%" */

#ifndef ASSERTH
#define ASSERTH

/*	@(#)assert.h 1.7 88/02/07 SMI; from UCB 4.2 85/01/21	*/

# ifndef NDEBUG
# define _assert(ex)	{if (!(ex)){(void)fprintf(stderr,"Assertion failed: file \"%s\", line %d\n", __FILE__, __LINE__);exit(1);}}
# define assert(ex)	_assert(ex)
# else
# define _assert(ex)
# define assert(ex)
# endif
 


extern "C" {
#ifndef _assert
	void _assert(const char*, const char*, int);
#endif
}

#endif

