create db demo;

Begin Declaration {

create type Date
tuple(
	dd		integer,
	mm		integer,
	yy		integer
)

Create Class Vehicle 
Tuple(
	id 		integer,
	color 		string[12],
        manufacturer 	ref( Company )
)

Create Class Company
Tuple(
	name		String[20],
	location	String[20],
	president	REF( Employee ),
	division	SET( Division )
)

Create Class Employee
Tuple(
	ssno		Integer,
	name		String[32],
	age		Integer,	
	residence	String[20],
	salary		Integer,
	hiredate	REF( Date ),
	drives		LIST( Vehicle ),
	manager		REF( Employee ),
        photo           OID,
	sound		OID
)


Create Class Division 
Tuple(
	functionality	String[20],
	staff		SET( Employee ),
	location	REF( City )
)

Create Class City
Tuple(
	name		String[20],
	population	Integer
)

Create Class DomesticCompany inherits from Company
Tuple(
	ExportTax	Integer
)

Create Class ForeignCompany inherits from Company
Tuple(
	ImportTax	Integer
)

};
