MoodSQL>select v.manufacturer.president.name from Vehicle v
>where (v.color='blue') and (v.manufacturer.name='GM');

QUERY RESULTS
=============
Paul Newman 


1 Objects are listed !


MoodSQL>select s.name, s.division.staff.name
>from Company s
>where (s.name = 'MGM') and (s.division.location.name = 'Los Angeles'); 

QUERY RESULTS
=============
MGM Robert Redford 
MGM Michael Douglas 
MGM Sharon Stone 
MGM Daniel Day Lewis 
MGM Catherine Deneuve 
MGM Harrison Ford 
MGM Kevin Costner 
MGM John Wayne 
MGM Marylin Monroe 
MGM Al Pacino 
MGM Dustin Hoffman 
MGM Paul Newman 
MGM Cindy Crawford 


13 Objects are listed !

MoodSQL>select e.name, s.division.location.name
>from Company s, Employee e
>where (s.name = 'MGM') and (s.president = e) and (e.age > 20);

QUERY RESULTS
=============
Catherine Deneuve Los Angeles 


1 Objects are listed !

MoodSQL>select v.manufacturer.division.staff.name
>from Vehicle v
>where (v.color = 'yellow') and (v.manufacturer.name = 'GM') and 
>      (v.manufacturer.division.staff.age = 28);


QUERY RESULTS
=============
Asuman Dogac 


1 Objects are listed !


#include "database.h"

int Employee::UpdateSal() {
  float pinc;

    if (ssno == 1)
        pinc = 1.3;
    else if (ssno == 2)
        pinc = 1.2;
    else
        pinc = 1.1;

    return( (int) (salary * pinc) );
}


MoodSQL>select s.name, s.salary, s.UpdateSal() 
>from Employee s
>where s.ssno < 10;

QUERY RESULTS
=============
Tansu Ciller 50000 64999 
Asuman Dogac 50000 60000 
Certan Ozkan 50000 55000 
Mehmet Altinel 50000 55000 
Ilker Altintas 50000 55000 
Budak Arpinar 50000 55000 
Suha Sevuk 50000 55000 
Tuncay Birand 50000 55000 


8 Objects are listed !

#include "database.h"

SET_Employee Division::GetStaff() {
   return staff;
}

MoodSQL>create function for class Division
>with prototype 'SET_Employee GetStaff()'
>using './GetStaff.c';


MoodSQL>select d.GetStaff().name
>from Division d
>where d.functionality = 'star';

QUERY RESULTS
=============
Robert Redford 
Michael Douglas 
Sharon Stone 
Daniel Day Lewis 
Catherine Deneuve 
Harrison Ford 
Kevin Costner 
John Wayne 
Marylin Monroe 
Al Pacino 
Dustin Hoffman 
Paul Newman 
Cindy Crawford 


13 Objects are listed !

MoodSQL>select d.president.name from DomesticCompany d;

QUERY RESULTS
=============
Tuncay Birand 


1 Objects are listed !


MoodSQL>select v.manufacturer.division.staff.name
>from Vehicle v
>where (v.manufacturer.division.location.name='Ankara') and (v.color='blue');


QUERY RESULTS
=============
Tansu Ciller 
Asuman Dogac 
Certan Ozkan 
Mehmet Altinel 
Ilker Altintas 
Budak Arpinar 
Mehmet Altinel 
Certan Ozkan 
Budak Arpinar 


9 Objects are listed !


MoodSQL>ls fnc of Employee;
FUNCTIONS
---------
__ct__8EmployeeFiPcT18REF_Date
Well_Paid_Emp__8EmployeeFi

MoodSQL>drop fnc with signature 'Well_Paid_Emp__8EmployeeFi'
>from class Employee;

MoodSQL>ls fnc of Employee;
FUNCTIONS
---------
__ct__8EmployeeFiPcT18REF_Date



MoodSQL>create function for class Division
>with prototype 'SET_Employee GetStaff()'
>using './GetStaff.c';

MoodSQL>select c.division.GetStaff().name
>from Company c
>where (c.president.age = 45) and (c.president.name = 'Tosun Terzioglu');


QUERY RESULTS
=============
Asuman Dogac 
Certan Ozkan 
Mehmet Altinel 
Ilker Altintas 
Budak Arpinar 


5 Objects are listed !


MoodSQL>select e.name
>from Employee e
>where (e.IsWellPaid(40000)) and (e.ssno = 3);

MoodSQL>select e.name, e.salary    
>from Employee e
>where e.IsWellPaid(80000);

QUERY RESULTS
=============
Tansu Ciller 100000 
Asuman Dogac 90000 
Suha Sevuk 90000 
Tuncay Birand 90000 
Tosun Terzioglu 90000 
Ersin Tulunay 90000 
Robert Redford 150000 
Michael Douglas 160000 
Sharon Stone 140000 
Daniel Day Lewis 120000 
Catherine Deneuve 100000 
Harrison Ford 100000 
Kevin Costner 160000 
Marylin Monroe 100000 
Al Pacino 200000 
Dustin Hoffman 150000 
Paul Newman 170000 
Cindy Crawford 250000 


18 Objects are listed !


MoodSQL>select e.name, e.salary
>from Employee e
>where e.IsWellPaid(80000)=FALSE; 
QUERY RESULTS
=============
Certan Ozkan 70000 
Mehmet Altinel 60000 
Ilker Altintas 60000 
Budak Arpinar 60000 
John Wayne 80000 


5 Objects are listed !
MoodSQL>select c.president.name
>from  Company c, Division d
>where (c.division.functionality=d.functionality) and (d.location.name='Ankara');
QUERY RESULTS
=============
Tosun Terzioglu 
Suha Sevuk 
Suha Sevuk 
Suha Sevuk 
Suha Sevuk 
Suha Sevuk 
Paul Newman 
Paul Newman 
Paul Newman 
Paul Newman 
Paul Newman 
11 Objects are listed !
MoodSQL>select c.name, c.division.location.name, o.name, o.division.location.name
>from Company o, Company c
>where (c.name='MGM') and (c.division.location=o.division.location);




QUERY RESULTS
=============
MGM Los Angeles METU Los Angeles
MGM Los Angeles MGM Los Angeles


2 Objects are listed !

MoodSQL>select c.name, c.division.functionality
>from Company c, Company o, Division d
>where (d.functionality='Software R&D Center') and
>(o.division.functionality=d.functionality) and
>(c.division.location=o.division.location) ;

QUERY RESULTS
=============
TUBITAK Software R&D Center 
TUBITAK Software R&D Center 
TUBITAK Software R&D Center 
METU top management 
METU top management 
METU top management 
METU Software R&D Center 
METU Software R&D Center 
METU Software R&D Center 
METU management 
METU management 
METU management 
METU development 
METU development 
METU development 
METU coding 
METU coding 
METU coding 
GM top management 
GM top management 
GM top management 
GM Software R&D Center 
GM Software R&D Center 
GM Software R&D Center 
GM management 
GM management 
GM management 
GM development 
GM development 
GM development 
GM coding 
GM coding 
GM coding 


33 Objects are listed!

MoodSQL>select c.name, c.division.staff.name
>from  Company c, Company o, Employee e
>where (c.division.staff.name=o.division.staff.name) and
>(o.name='METU') and (o.division.staff.name=e.name) and
>(e.age=45);


QUERY RESULTS
=============
METU Dustin Hoffman 
MGM Dustin Hoffman 


2 Objects are listed !

MoodSQL>select c.name, c.division.functionality
>from Company c, Company o, Division d
>where (d.functionality='Software R&D Center') and
>(o.division.functionality=d.functionality) and
>(c.division.location=o.division.location) and (c.name='METU');


QUERY RESULTS
=============
METU top management 
METU Software R&D Center 
METU management 
METU development 
METU coding 
METU top management 
METU Software R&D Center 
METU management 
METU development 
METU coding 
METU top management 
METU Software R&D Center 
METU management 
METU development 
METU coding 


15 Objects are listed !

MoodSQL>delete e from Employee e where e.ssno=3;


Object not deleted because of existing references

 
MoodSQL>select * from Employee e;


MoodSQL>delete v from Vehicle v where v.color='black';

MoodSQL>delete c from Company c where c.name='METU';



Object deleted successfully... 

MoodSQL>select c.name from Company c ;



QUERY RESULTS
=============
TUBITAK 
MGM 
GM 


3 Objects are listed !


 
MoodSQL>select v.manufacturer.name
>from Vehicle v
>where (v.color = 'red') and (v.manufacturer.president.drives.id = v.id);


QUERY RESULTS
=============
GM


1 Objects are listed !

MoodSQL>select v.manufacturer.name, c.president.name
>from Vehicle v, Company c
>where (v.color = 'red') and (v.manufacturer.president=c.president)
>and (c.name='GM');
QUERY RESULTS
=============
GM Paul Newman


1 Objects are listed !



MoodSQL>select c.president.name
>from  Company c
>where c.president.drives.manufacturer=c;

QUERY RESULTS
=============
Paul Newman 
Paul Newman 
Paul Newman 


3 Objects are listed !


MoodSQL>update Company c
>set c.president=(select e from Employee e
>where (e.drives.color='red') and (e.ssno=2))
>where c.name='METU';


MoodSQL>select c.president.name
>from Company c
>where c.name='METU';


QUERY RESULTS
=============
Asuman Dogac 


1 Objects are listed !


MoodSQL>describe Employee;
 User Class Employee
 Inherits from MoodsRoot
 TUPLE (
    ssno       INTEGER ,
    name       STRING[32] ,
    age        INTEGER ,
    residence  STRING[20] ,
    salary    INTEGER ,
    hiredate   REF( Date ),
    drives    LIST( Vehicle ),
    manager   REF( Employee ),
    photo  OID ,
  )

MoodSQL>list function of Employee;
FUNCTIONS
---------
__ct__8EmployeeFiPcN218REF_DateT2
IsWellPaid__8EmployeeFi
ShowPhoto__8EmployeeFv
GetAge__8EmployeeFi


MoodSQL>list database;
LIST OF DATABASES
-----------------
sigmod_demo
certan
xxxx
set_dene
yuksel_demo
ilker
eleman
ana


MoodSQL>delete c from Company c 
>where ( c.division.staff.salary>100000) and (c.division.staff.ssno=14);

Object deleted successfully...


MoodSQL>select c.name from Company c;

QUERY RESULTS
=============
TUBITAK 
GM 


2 Objects are listed !

MoodSQL>list type;
                     TYPE NAME SIZE   ID   TYPE TYPE! 
 _____________________________ ____ ____ ____________ 
                       INTEGER    4    1 BASIC TYPE
                         FLOAT    4    2 BASIC TYPE
                       BOOLEAN    1    3 BASIC TYPE
                          CHAR    1    4 BASIC TYPE
                        STRING    1    5 BASIC TYPE
                           OID   12    6 BASIC TYPE
                           IID    8    7 BASIC TYPE
                           FID   12    8 BASIC TYPE
                         TUPLE    0    9 SYSTEM TYPE
                           SET   12   10 SYSTEM TYPE
                          LIST   12   11 SYSTEM TYPE
                           REF   12   12 SYSTEM TYPE
                     MoodsRoot    4   14 USER CLASS
                       Vehicle   32   15 USER CLASS
                      Employee  116   16 USER CLASS
                          Date   16   18 USER TYPE
                          City   28   20 USER CLASS
                      Division   48   24 USER CLASS
                       Company   68   28 USER CLASS
               DomesticCompany   72   30 USER CLASS
                ForeignCompany   72   32 USER CLASS



MoodSQL>Describe DomesticCompany;
 User Class DomesticCompany
 Inherits from Company
 TUPLE (
    ExportTax  INTEGER ,
  )



MoodSQL>select c.name, c.division.functionality
>from Company c, Company o, Division d
>where (d.functionality='Software R&D Center') and
>(o.division.functionality=d.functionality) and
>(c.division.location=o.division.location) and (c.name='METU');


QUERY RESULTS
=============
METU top management 
METU Software R&D Center 
METU management 
METU development 
METU coding 
METU top management 
METU Software R&D Center 
METU management 
METU development 
METU coding 
METU top management 
METU Software R&D Center 
METU management 
METU development 
METU coding 


15 Objects are listed !



MoodSQL>select c.name, e.name, e.salary
>from Company c, Employee e
>where ( c.division.staff.IsWellPaid(150000)=TRUE) and
>(c.division.staff.name=e.name);

QUERY RESULTS
=============
METU Michael Douglas 160000 
METU Kevin Costner 160000 
METU Al Pacino 200000 
METU Paul Newman 170000 
METU Cindy Crawford 250000 
MGM Michael Douglas 160000 
MGM Kevin Costner 160000 
MGM Al Pacino 200000 
MGM Paul Newman 170000 
MGM Cindy Crawford 250000 


10 Objects are listed !


