#include "mood_catalog.h"

int CatATTRIBUTE::writeAttr(AttributeType PAttribute, OID *PAttrOid) 
{
	int err;

	mscat_CreateObject( AttributeFid, sizeof( AttributeType), &PAttribute,PAttrOid,"error writing attribute entry "); 
	return TRUE;
}


void CatATTRIBUTE::disp_attr(AttributeType Pattr) {
     printf( "++++++++++++++++++++++++++++++++++++++++++++\n");
     printf( "NAME: %s\n  ",    Pattr.AttributeName );
     printf( "OFFSET:%d\n   ",  Pattr.AttributeOffset);
     printf( "LENGTH:%d\n   ",  Pattr.AttributeLength);
     printf( "CONSTRUCT:%d\n",  Pattr.AttributeConstructor);
     //printf( "TYPE :%s\n" ; display_Oid(Pattr.AttributeType) ;
     printf( "++++++++++++++++++++++++++++++++++++++++++++\n");
}


CatATTRIBUTE::CatATTRIBUTE( FID AttrFile ) 
{
     // initialize the file name to store attributes ...
     memcpy( (char *)&AttributeFid, (char *)&AttrFile, sizeof(FID) );
}

/******** DO NOT REMOVE
CatATTRIBUTE::CatATTRIBUTE( FID AttrFile , OID *PAttrOid ) 
{ 
	int 		err;
	AttributeType 	AttrIntern;

	mscat_ReadObject( (*PAttrOid),"can not read attribute entry"); 
    
	memcpy((char *)&AttrIntern , (char *)UserDesc->basePtr, sizeof(AttrIntern) );

	mscat_ReleaseObject("release object attribute"); 

}
*******************/


int CatATTRIBUTE::readAttr(OID AttributeOid,AttributeType *AttrIntern, CatBOOLEAN *status) 
{
	int err;

	mscat_ReadObject( AttributeOid,"error on reading attribute entry");

	if ( err != esmNOERROR) *status = 1 ;
	else { // succeded to read attribute ...
		memcpy((char*) AttrIntern,(char *) UserDesc->basePtr, sizeof( AttributeType));
		// initialize member values....
		*status = 0 ;
		mscat_ReleaseObject("error on release");
	}
	return TRUE;
}


int CatATTRIBUTE::updateAttr(OID Pattroid, AttributeType Pattrinfo ) 
{
	int err;

	mscat_ReadObject( Pattroid, "reading updated object");

	mscat_WriteObject( sizeof(AttributeType), &Pattrinfo,"writing updated object");

	mscat_ReleaseObject( "releasing object ");

	return TRUE;
}

