#include "keywords.h"
#include "mood_catdef.h"
#include "mood_catalog.h"

/* modify this routine so that when the entry is not found it return -1. */

int ms_LocateObject( FID *fid, int keytype, char *key, int offset, OID *oid, int typeId = -1 )
{
	OID oid1,oid2;
	int err;
	OBJHDR ObjectHeader;
	USERDESC *UserDesc;
	char eof = FALSE;

	mscat_GetFirstOid( (*fid),oid1, "Cannot read the first OID, in create index" );

	while( eof !=TRUE ){
	
	   mscat_ReadObject(oid1, "Cannot read the object , in create index" );
	   if( (typeId == -1) || (*( ( int *)(UserDesc->basePtr)) == typeId) ){
	   	switch( keytype ){
	      		case INTEGER: 
							if(*((int *)&UserDesc->basePtr[offset])==*((int *)key)){ 
	             		memcpy(oid, &oid1, sizeof( OID ) );
                  mscat_ReleaseObject("Cannot release object in locate object");
                  return 1;
              }
              break;
            case CHAR: 
              if(strcmp((char *)&UserDesc->basePtr[offset],key) == 0){
                 memcpy(oid, &oid1, sizeof( OID ) );
                 mscat_ReleaseObject("Cannot release object in locate object");
                 return 1;
              }
              break;

	   	}
	   }
     mscat_ReleaseObject( "Cannot release object in locate object" );

     mscat_GetNextOid(oid1, oid2, "Cannot read the next OID" );

     memcpy( &oid1, &oid2, sizeof( OID ) );
	}
        
	INVALIDATE_OID( *oid );
	return TRUE;

}
