#include <X11/cursorfont.h>
#include <stdio.h>
#include <malloc.h>
#include <sys/types.h>
#include <Mrm/MrmAppl.h>
#include <Xm/LabelG.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>
#include <Xm/Separator.h>
#include <Xm/Form.h>
#include <Xm/ToggleBG.h>
#include <Xm/Frame.h>
#include <Xm/DrawnB.h>
#include <Xm/XmP.h>
#include <Xm/List.h>
#include <Xm/MainW.h>
#include <Xm/CascadeBG.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/ArrowBG.h>
#include <Xm/PanedW.h>

#define GERMAN  0
#define ENGLISH 1

struct mine {
  char clname[150];
  int flag;
};
typedef struct mine *Pmine;

struct crclst {
    char clname[150];
    char superls[250];
    char attls[500];
};
typedef struct crclst *Pcrclst;

typedef struct _menu_item {
    char        *label;         /* the label for the item */
    WidgetClass *m_class;         /* pushbutton, label, separator... */
    char         mnemonic;      /* mnemonic; NULL if none */
    char        *accelerator;   /* accelerator; NULL if none */
    char        *accel_text;    /* to be converted to compound string */
    void       (*callback)(struct _WidgetRec*,void *,void *);   /* routine to call; NULL if none */
    XtPointer    callback_data; /* client_data for callback() */
    struct _menu_item *subitems; /* pullright menu items, if not NULL */
} MenuItem;

extern void attCB(Widget w,XtPointer client_data,XmListCallbackStruct *cbs);
Widget BuildList(Widget parent,char * title,char * ite[],int  n);
void list_proc(Widget list_w, XtPointer client_data, XmListCallbackStruct *cb);
Widget CreateLabeledTextForm(Widget parent,char *label_name,char * text_name,char * def_text);
void ClassCB(Widget w,Pmine client_data,XtPointer call_data);
void submenu(Widget widget, int select);
void  ex_prog();
void metmenu(Widget widget,int  select);
void savecl();
void editorCB(Widget w,XtPointer client_data,XtPointer call_data);
static void penCB(Widget w, XtPointer client_data,XmListCallbackStruct *cbs);
static void pen2CB(Widget w, XtPointer client_data, XmListCallbackStruct *cbs);
void pencil(int select, Widget w,XmListCallbackStruct * cbs);
static void ChangeRet1(Widget w, char *client_data, XmListCallbackStruct *cbs);
static void ChangeRet2(Widget w, char *client_data, XmListCallbackStruct *cbs);
Widget vir_para(Widget w, char *def_name, char *def_type);
void add_para();
void save_method();
void drop_para();
void ex_menu(Widget widget);
Widget make_frame(Widget w);
XmStringCharSet  charset;
Widget BuildPulldownMenu(Widget parent,char * menu_title,char menu_mnemonic,MenuItem *items);
Widget make_label(Widget w, char *title);   
Widget make_rowcol(Widget w);
void dialogue(Widget);
XtArgVal GetPixel(char *colorstr);
static void redraw_button(Widget button, Pixmap pixmap,XmDrawnButtonCallbackStruct *cbs);
void do_it(Widget w,int select,XmListCallbackStruct *cbs);
void listdb(int);
void opendbCB (Widget, XtPointer, XtPointer);
void newdbCB (Widget, XtPointer, XtPointer);
void deletedbCB (Widget w,XtPointer, XtPointer);
