#if !defined(__MEMMNG_H)
#define __MEMMNG_H

// make this also a class

struct bufSeg {
   
   void * start;
   int curr;
   OID oid;
   int currInObj;

};

class MemMng {

   uint segSize, Size;
   uint nSeg;
   int  bgIdx;
   bufSeg * segments;

public :

MemMng();
MemMng(void * buf, uint size, uint segs, OID * segOIDs, int bg);
~MemMng();

int Setup(byte * buf, uint size, uint segs, OID * segOIDs, int bg);
int Write(uint segNo, byte *data, uint dSize);
void Destroy();
int Flush(bufSeg *b);
int FlushAll();
int isAvail(uint segNo, uint freeSize);
int oCount(uint segNo, uint oSize);

};

#endif


