#include "opt_defs.h"
#include "global.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
extern TRACE	trace ;
extern int	indent_value ;

#if defined(__cplusplus) || defined(ANSI)
char *error_text (int) ;
STATUS derive_JOIN_sys_prop (    OPERATOR_ARGUMENT *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    SYSTEM_PROPERTY *) ;
STATUS derive_JOIN_log_prop (    OPERATOR_ARGUMENT *,
    LOGICAL_PROPERTY **,
    LOGICAL_PROPERTY *) ;
STATUS derive_SELECT_sys_prop (    OPERATOR_ARGUMENT *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    SYSTEM_PROPERTY *) ;
STATUS derive_SELECT_log_prop (    OPERATOR_ARGUMENT *,
    LOGICAL_PROPERTY **,
    LOGICAL_PROPERTY *) ;
STATUS derive_GET_SET_sys_prop (    OPERATOR_ARGUMENT *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    SYSTEM_PROPERTY *) ;
STATUS derive_GET_SET_log_prop (    OPERATOR_ARGUMENT *,
    LOGICAL_PROPERTY **,
    LOGICAL_PROPERTY *) ;
STATUS derive_MAT_sys_prop (    OPERATOR_ARGUMENT *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    SYSTEM_PROPERTY *) ;
STATUS derive_MAT_log_prop (    OPERATOR_ARGUMENT *,
    LOGICAL_PROPERTY **,
    LOGICAL_PROPERTY *) ;
STATUS derive_UNNEST_sys_prop (    OPERATOR_ARGUMENT *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    SYSTEM_PROPERTY *) ;
STATUS derive_UNNEST_log_prop (    OPERATOR_ARGUMENT *,
    LOGICAL_PROPERTY **,
    LOGICAL_PROPERTY *) ;
STATUS derive_UNION_sys_prop (    OPERATOR_ARGUMENT *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    SYSTEM_PROPERTY *) ;
STATUS derive_UNION_log_prop (    OPERATOR_ARGUMENT *,
    LOGICAL_PROPERTY **,
    LOGICAL_PROPERTY *) ;
STATUS derive_FIX_sys_prop (    OPERATOR_ARGUMENT *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    SYSTEM_PROPERTY *) ;
STATUS derive_FIX_log_prop (    OPERATOR_ARGUMENT *,
    LOGICAL_PROPERTY **,
    LOGICAL_PROPERTY *) ;
STATUS cost_HASH_JOIN (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_HASH_JOIN (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_HASH_JOIN_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_HASH_JOIN (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_MERGE_JOIN (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_MERGE_JOIN (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_MERGE_JOIN_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_MERGE_JOIN (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_FILTER (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_FILTER (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_FILTER_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_FILTER (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_FILE_SCAN (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_FILE_SCAN (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_FILE_SCAN_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_FILE_SCAN (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_BTREE_SELECT (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_BTREE_SELECT (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_BTREE_SELECT_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_BTREE_SELECT (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_TRAVERSE (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_TRAVERSE (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_TRAVERSE_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_TRAVERSE (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_PTR_HH_JOIN (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_PTR_HH_JOIN (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_PTR_HH_JOIN_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_PTR_HH_JOIN (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_PTR_SM_JOIN (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_PTR_SM_JOIN (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_PTR_SM_JOIN_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_PTR_SM_JOIN (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_UNNEST_ALG (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_UNNEST_ALG (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_UNNEST_ALG_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_UNNEST_ALG (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_NESTED_LOOP_JOIN (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_NESTED_LOOP_JOIN (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_NESTED_LOOP_JOIN_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_NESTED_LOOP_JOIN (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_UNION_ALG (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_UNION_ALG (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_UNION_ALG_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_UNION_ALG (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_FIX_ALG (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_FIX_ALG (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_FIX_ALG_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_FIX_ALG (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);
STATUS cost_SORT (    ALGORITHM_ARGUMENT *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, SYSTEM_PROPERTY **,
    LOGICAL_PROPERTY **, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, PROPERTY_VECTOR **,
    COST *) ;
STATUS do_any_good_SORT (    OPERATOR *, OPERATOR_ARGUMENT *,
    PROPERTY_VECTOR *, SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *, PROPERTY_VECTOR *,
    OPERATOR [], ALGO_APPL_RETURN *) ;
STATUS derive_SORT_phy_prop (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *, LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *, PROPERTY_VECTOR *) ;
STATUS get_input_pv_SORT (    ALGORITHM_ARGUMENT *, PROPERTY_VECTOR *,
    PROPERTY_VECTOR *, int, int,
    PROPERTY_VECTOR **, PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **, LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **, COST **, BOOLEAN *);

#else
char *error_text () ;
STATUS derive_JOIN_sys_prop () ;
STATUS derive_JOIN_log_prop () ;
STATUS derive_SELECT_sys_prop () ;
STATUS derive_SELECT_log_prop () ;
STATUS derive_GET_SET_sys_prop () ;
STATUS derive_GET_SET_log_prop () ;
STATUS derive_MAT_sys_prop () ;
STATUS derive_MAT_log_prop () ;
STATUS derive_UNNEST_sys_prop () ;
STATUS derive_UNNEST_log_prop () ;
STATUS derive_UNION_sys_prop () ;
STATUS derive_UNION_log_prop () ;
STATUS derive_FIX_sys_prop () ;
STATUS derive_FIX_log_prop () ;
STATUS cost_HASH_JOIN () ;
STATUS do_any_good_HASH_JOIN () ;
STATUS derive_HASH_JOIN_phy_prop () ;
STATUS get_input_pv_HASH_JOIN () ;
STATUS cost_MERGE_JOIN () ;
STATUS do_any_good_MERGE_JOIN () ;
STATUS derive_MERGE_JOIN_phy_prop () ;
STATUS get_input_pv_MERGE_JOIN () ;
STATUS cost_FILTER () ;
STATUS do_any_good_FILTER () ;
STATUS derive_FILTER_phy_prop () ;
STATUS get_input_pv_FILTER () ;
STATUS cost_FILE_SCAN () ;
STATUS do_any_good_FILE_SCAN () ;
STATUS derive_FILE_SCAN_phy_prop () ;
STATUS get_input_pv_FILE_SCAN () ;
STATUS cost_BTREE_SELECT () ;
STATUS do_any_good_BTREE_SELECT () ;
STATUS derive_BTREE_SELECT_phy_prop () ;
STATUS get_input_pv_BTREE_SELECT () ;
STATUS cost_TRAVERSE () ;
STATUS do_any_good_TRAVERSE () ;
STATUS derive_TRAVERSE_phy_prop () ;
STATUS get_input_pv_TRAVERSE () ;
STATUS cost_PTR_HH_JOIN () ;
STATUS do_any_good_PTR_HH_JOIN () ;
STATUS derive_PTR_HH_JOIN_phy_prop () ;
STATUS get_input_pv_PTR_HH_JOIN () ;
STATUS cost_PTR_SM_JOIN () ;
STATUS do_any_good_PTR_SM_JOIN () ;
STATUS derive_PTR_SM_JOIN_phy_prop () ;
STATUS get_input_pv_PTR_SM_JOIN () ;
STATUS cost_UNNEST_ALG () ;
STATUS do_any_good_UNNEST_ALG () ;
STATUS derive_UNNEST_ALG_phy_prop () ;
STATUS get_input_pv_UNNEST_ALG () ;
STATUS cost_NESTED_LOOP_JOIN () ;
STATUS do_any_good_NESTED_LOOP_JOIN () ;
STATUS derive_NESTED_LOOP_JOIN_phy_prop () ;
STATUS get_input_pv_NESTED_LOOP_JOIN () ;
STATUS cost_UNION_ALG () ;
STATUS do_any_good_UNION_ALG () ;
STATUS derive_UNION_ALG_phy_prop () ;
STATUS get_input_pv_UNION_ALG () ;
STATUS cost_FIX_ALG () ;
STATUS do_any_good_FIX_ALG () ;
STATUS derive_FIX_ALG_phy_prop () ;
STATUS get_input_pv_FIX_ALG () ;
STATUS cost_SORT () ;
STATUS do_any_good_SORT () ;
STATUS derive_SORT_phy_prop () ;
STATUS get_input_pv_SORT () ;

#endif

int opt_arity[NUM_OPERATORS]={2,1,0,1,1,2,1};

int algo_arity[NUM_ALGORITHMS]={2,2,1,0,0,1,1,1,1,2,2,1,1};

#if defined(__cplusplus) || defined (ANSI)
STATUS get_enforcer(int count,ALGORITHM *enforcer)
#else
STATUS get_enforcer(count,enforcer)
int count ; ALGORITHM *enforcer;

#endif
{switch (count)
{
case 0: *enforcer = SORT; break;
default: *enforcer = (ALGORITHM) NO_MORE; break;
    }
return (OKAY);
}

#if defined(__cplusplus) || defined (ANSI)
STATUS derive_sys_prop(OPERATOR my_operator,OPERATOR_ARGUMENT *oa,SYSTEM_PROPERTY **input_sys_prop,
LOGICAL_PROPERTY **input_log_prop,
SYSTEM_PROPERTY *derived_sys_prop)
#else
STATUS derive_sys_prop(my_operator,oa,input_sys_prop,
input_log_prop,derived_sys_prop)
OPERATOR my_operator;OPERATOR_ARGUMENT *oa;
SYSTEM_PROPERTY *input_sys_prop[], *derived_sys_prop;
LOGICAL_PROPERTY *input_log_prop[];
#endif
{
 STATUS error;
switch (my_operator) {
case (JOIN): CALL (derive_JOIN_sys_prop
(oa,input_sys_prop,input_log_prop,
derived_sys_prop)); break;
case (SELECT): CALL (derive_SELECT_sys_prop
(oa,input_sys_prop,input_log_prop,
derived_sys_prop)); break;
case (GET_SET): CALL (derive_GET_SET_sys_prop
(oa,input_sys_prop,input_log_prop,
derived_sys_prop)); break;
case (MAT): CALL (derive_MAT_sys_prop
(oa,input_sys_prop,input_log_prop,
derived_sys_prop)); break;
case (UNNEST): CALL (derive_UNNEST_sys_prop
(oa,input_sys_prop,input_log_prop,
derived_sys_prop)); break;
case (UNION): CALL (derive_UNION_sys_prop
(oa,input_sys_prop,input_log_prop,
derived_sys_prop)); break;
case (FIX): CALL (derive_FIX_sys_prop
(oa,input_sys_prop,input_log_prop,
derived_sys_prop)); break;
default: FAIL (ERR_UNKNOWN_OPERATOR);
}
return (OKAY) ;
}

#if defined(__cplusplus) || defined (ANSI)
STATUS derive_log_prop(OPERATOR my_operator,OPERATOR_ARGUMENT *oa,LOGICAL_PROPERTY **input_log_prop,
LOGICAL_PROPERTY *derived_log_prop)
#else
STATUS derive_log_prop(my_operator,oa,input_log_prop,
derived_log_prop)
OPERATOR my_operator;OPERATOR_ARGUMENT *oa;
LOGICAL_PROPERTY *input_log_prop[], *derived_log_prop;
#endif
{
 STATUS error;
init_logical_prop(derived_log_prop) ;
switch (my_operator) {
case (JOIN): CALL (derive_JOIN_log_prop
(oa, input_log_prop,
derived_log_prop)); break;
case (SELECT): CALL (derive_SELECT_log_prop
(oa, input_log_prop,
derived_log_prop)); break;
case (GET_SET): CALL (derive_GET_SET_log_prop
(oa, input_log_prop,
derived_log_prop)); break;
case (MAT): CALL (derive_MAT_log_prop
(oa, input_log_prop,
derived_log_prop)); break;
case (UNNEST): CALL (derive_UNNEST_log_prop
(oa, input_log_prop,
derived_log_prop)); break;
case (UNION): CALL (derive_UNION_log_prop
(oa, input_log_prop,
derived_log_prop)); break;
case (FIX): CALL (derive_FIX_log_prop
(oa, input_log_prop,
derived_log_prop)); break;
default: FAIL (ERR_UNKNOWN_OPERATOR);
}
return (OKAY) ;
}

#if defined(__cplusplus) || defined (ANSI)
STATUS estimate_cost(ALGORITHM algorithm_or_enforcer,ALGORITHM_ARGUMENT *aa,SYSTEM_PROPERTY *sys_prop,LOGICAL_PROPERTY *log_prop,
SYSTEM_PROPERTY **input_sys_prop,LOGICAL_PROPERTY **input_log_prop,
PROPERTY_VECTOR *needed_pv,PROPERTY_VECTOR *derived_pv,
PROPERTY_VECTOR **input_pv,
COST *ret_cost)
#else
STATUS estimate_cost(algorithm_or_enforcer,aa,sys_prop,log_prop,
input_sys_prop,input_log_prop,needed_pv,derived_pv,input_pv,
ret_cost)
ALGORITHM algorithm_or_enforcer;ALGORITHM_ARGUMENT *aa;
SYSTEM_PROPERTY *input_sys_prop[], *sys_prop;
LOGICAL_PROPERTY *input_log_prop[], *log_prop;
PROPERTY_VECTOR *needed_pv, *derived_pv, *input_pv[];
COST *ret_cost;
#endif
{
STATUS error;
switch (algorithm_or_enforcer) {
case (HASH_JOIN): CALL (cost_HASH_JOIN
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (MERGE_JOIN): CALL (cost_MERGE_JOIN
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (FILTER): CALL (cost_FILTER
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (FILE_SCAN): CALL (cost_FILE_SCAN
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (BTREE_SELECT): CALL (cost_BTREE_SELECT
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (TRAVERSE): CALL (cost_TRAVERSE
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (PTR_HH_JOIN): CALL (cost_PTR_HH_JOIN
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (PTR_SM_JOIN): CALL (cost_PTR_SM_JOIN
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (UNNEST_ALG): CALL (cost_UNNEST_ALG
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (NESTED_LOOP_JOIN): CALL (cost_NESTED_LOOP_JOIN
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (UNION_ALG): CALL (cost_UNION_ALG
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (FIX_ALG): CALL (cost_FIX_ALG
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
case (SORT): CALL (cost_SORT
(aa, sys_prop,log_prop,
input_sys_prop,input_log_prop,
needed_pv, derived_pv, input_pv, ret_cost)) ; break;
default: FAIL (ERR_UNKNOWN_ALGORITHM);
}
return (OKAY) ;
}

#if defined(__cplusplus) || defined (ANSI)
STATUS do_any_good(ALGORITHM * algorithm_or_enforcer,
OPERATOR * current_operator,
OPERATOR_ARGUMENT *oa,PROPERTY_VECTOR * needed_pv,
SYSTEM_PROPERTY *sys_prop,
LOGICAL_PROPERTY * log_prop,PROPERTY_VECTOR *excl_pv,
OPERATOR input_operator[], 
ALGO_APPL_RETURN *ret_value)
#else
STATUS do_any_good(algorithm_or_enforcer,current_operator,
oa,needed_pv,sys_prop,
log_prop,excl_pv,input_operator,
ret_value)
ALGORITHM *algorithm_or_enforcer;OPERATOR *current_operator;
OPERATOR_ARGUMENT *oa;
SYSTEM_PROPERTY *sys_prop;
LOGICAL_PROPERTY *log_prop;
PROPERTY_VECTOR *needed_pv, *excl_pv;
OPERATOR input_operator[] ;
ALGO_APPL_RETURN *ret_value ;
#endif
{
STATUS error;
switch (*algorithm_or_enforcer) {
case (HASH_JOIN): CALL (do_any_good_HASH_JOIN
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (MERGE_JOIN): CALL (do_any_good_MERGE_JOIN
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (FILTER): CALL (do_any_good_FILTER
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (FILE_SCAN): CALL (do_any_good_FILE_SCAN
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (BTREE_SELECT): CALL (do_any_good_BTREE_SELECT
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (TRAVERSE): CALL (do_any_good_TRAVERSE
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (PTR_HH_JOIN): CALL (do_any_good_PTR_HH_JOIN
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (PTR_SM_JOIN): CALL (do_any_good_PTR_SM_JOIN
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (UNNEST_ALG): CALL (do_any_good_UNNEST_ALG
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (NESTED_LOOP_JOIN): CALL (do_any_good_NESTED_LOOP_JOIN
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (UNION_ALG): CALL (do_any_good_UNION_ALG
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (FIX_ALG): CALL (do_any_good_FIX_ALG
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
case (SORT): CALL (do_any_good_SORT
(current_operator, oa, needed_pv,
sys_prop,log_prop,
excl_pv, input_operator, ret_value)) ; break;
default: FAIL (ERR_UNKNOWN_ALGORITHM);
}
return (OKAY) ;
}

#if defined(__cplusplus) || defined (ANSI)
STATUS derive_phy_prop(ALGORITHM algorithm_or_enforcer,
ALGORITHM_ARGUMENT *aa,PROPERTY_VECTOR **input_pv,
SYSTEM_PROPERTY *sys_prop,
LOGICAL_PROPERTY *log_prop,
SYSTEM_PROPERTY **input_sys_prop,LOGICAL_PROPERTY **input_log_prop,
PROPERTY_VECTOR *needed_pv,PROPERTY_VECTOR *derived_pv)
#else
STATUS derive_phy_prop(algorithm_or_enforcer,aa,input_pv,sys_prop,
log_prop,input_sys_prop,input_log_prop,needed_pv,derived_pv)
ALGORITHM algorithm_or_enforcer;ALGORITHM_ARGUMENT *aa;
SYSTEM_PROPERTY *sys_prop, *input_sys_prop[];
LOGICAL_PROPERTY *log_prop, *input_log_prop[];
PROPERTY_VECTOR *input_pv[], *needed_pv, *derived_pv;
#endif
{
STATUS error;
switch (algorithm_or_enforcer) {
case (HASH_JOIN): CALL (derive_HASH_JOIN_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (MERGE_JOIN): CALL (derive_MERGE_JOIN_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (FILTER): CALL (derive_FILTER_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (FILE_SCAN): CALL (derive_FILE_SCAN_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (BTREE_SELECT): CALL (derive_BTREE_SELECT_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (TRAVERSE): CALL (derive_TRAVERSE_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (PTR_HH_JOIN): CALL (derive_PTR_HH_JOIN_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (PTR_SM_JOIN): CALL (derive_PTR_SM_JOIN_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (UNNEST_ALG): CALL (derive_UNNEST_ALG_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (NESTED_LOOP_JOIN): CALL (derive_NESTED_LOOP_JOIN_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (UNION_ALG): CALL (derive_UNION_ALG_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (FIX_ALG): CALL (derive_FIX_ALG_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
case (SORT): CALL (derive_SORT_phy_prop
(aa, input_pv,
sys_prop,log_prop,input_sys_prop,
input_log_prop,needed_pv,derived_pv)) ; break;
default: FAIL (ERR_UNKNOWN_ALGORITHM);
}
return (OKAY) ;
}

#if defined(__cplusplus) || defined (ANSI)
STATUS get_input_pv(ALGORITHM algorithm_or_enforcer,
ALGORITHM_ARGUMENT *aa,PROPERTY_VECTOR *needed_pv,
PROPERTY_VECTOR *excl_pv,
int input_id,int iteration,PROPERTY_VECTOR **input_pv,
PROPERTY_VECTOR **input_excl_pv,
SYSTEM_PROPERTY *input_sys_prop[],LOGICAL_PROPERTY *input_log_prop[],
PHY_EXPR_LIST_ELEM **input_ret_pele,
COST **input_ret_cost,BOOLEAN *fail)
#else
STATUS get_input_pv(algorithm_or_enforcer,aa,needed_pv,excl_pv,
input_id,iteration,input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail)
ALGORITHM algorithm_or_enforcer;ALGORITHM_ARGUMENT *aa;
PROPERTY_VECTOR *needed_pv, *excl_pv ;
PROPERTY_VECTOR *input_pv[], *input_excl_pv[] ;
int input_id, iteration;
SYSTEM_PROPERTY *input_sys_prop[] ;
LOGICAL_PROPERTY *input_log_prop[] ;
PHY_EXPR_LIST_ELEM *input_ret_pele[] ;
COST *input_ret_cost[] ;
BOOLEAN *fail ;
#endif
{
STATUS error;
switch (algorithm_or_enforcer) {
case (HASH_JOIN): CALL (get_input_pv_HASH_JOIN
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (MERGE_JOIN): CALL (get_input_pv_MERGE_JOIN
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (FILTER): CALL (get_input_pv_FILTER
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (TRAVERSE): CALL (get_input_pv_TRAVERSE
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (PTR_HH_JOIN): CALL (get_input_pv_PTR_HH_JOIN
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (PTR_SM_JOIN): CALL (get_input_pv_PTR_SM_JOIN
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (UNNEST_ALG): CALL (get_input_pv_UNNEST_ALG
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (NESTED_LOOP_JOIN): CALL (get_input_pv_NESTED_LOOP_JOIN
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (UNION_ALG): CALL (get_input_pv_UNION_ALG
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (FIX_ALG): CALL (get_input_pv_FIX_ALG
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
case (SORT): CALL (get_input_pv_SORT
(aa, needed_pv,
excl_pv,input_id,iteration,
input_pv,input_excl_pv,
input_sys_prop,input_log_prop,input_ret_pele,input_ret_cost,fail));
break;
default: FAIL (ERR_UNKNOWN_ALGORITHM);
}
return (OKAY) ;
}
