#define MAX_GROUPS	10
#define DEFAULT        0

#define TRANS_RULE_COUNT 12

#define IMPL_RULE_COUNT 11

#define MAX_OPERATOR_ARITY 2
#define NUM_OPERATORS 7

#define MAX_ALGORITHM_ARITY 2
#define NUM_ALGORITHMS 13

#define print_rule_group(rg)\
if ((rg) == DEFAULT) printf ("DEFAULT\n") ;\
else FAIL (ERR_UNKNOWN_RULE_GROUP) ;

#define print_operator(op)\
if ((op) == JOIN) printf ("JOIN\n") ;\
else if ((op) == SELECT) printf ("SELECT\n") ;\
else if ((op) == GET_SET) printf ("GET_SET\n") ;\
else if ((op) == MAT) printf ("MAT\n") ;\
else if ((op) == UNNEST) printf ("UNNEST\n") ;\
else if ((op) == UNION) printf ("UNION\n") ;\
else if ((op) == FIX) printf ("FIX\n") ;\
else FAIL (ERR_UNKNOWN_OPERATOR) ;

#define print_algorithm(m)\
if ((m) == HASH_JOIN) printf ("HASH_JOIN\n") ;\
else if ((m) == MERGE_JOIN) printf ("MERGE_JOIN\n") ;\
else if ((m) == FILTER) printf ("FILTER\n") ;\
else if ((m) == FILE_SCAN) printf ("FILE_SCAN\n") ;\
else if ((m) == BTREE_SELECT) printf ("BTREE_SELECT\n") ;\
else if ((m) == TRAVERSE) printf ("TRAVERSE\n") ;\
else if ((m) == PTR_HH_JOIN) printf ("PTR_HH_JOIN\n") ;\
else if ((m) == PTR_SM_JOIN) printf ("PTR_SM_JOIN\n") ;\
else if ((m) == UNNEST_ALG) printf ("UNNEST_ALG\n") ;\
else if ((m) == NESTED_LOOP_JOIN) printf ("NESTED_LOOP_JOIN\n") ;\
else if ((m) == UNION_ALG) printf ("UNION_ALG\n") ;\
else if ((m) == FIX_ALG) printf ("FIX_ALG\n") ;\
else if ((m) == SORT) printf ("SORT\n") ;\
else FAIL (ERR_UNKNOWN_ALGORITHM) ;
