#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "expr_str.h"
#include "global.h"

extern int indent_value ;
#if defined(__cplusplus) || defined(ANSI)
extern char * error_text (int) ;
STATUS link_eq_classes(STORAGE_SEG_ANCHOR *,int,int) ;
STATUS generate_all_transformations(LOG_EXPR_LIST_ELEM *,int,STORAGE_SEG_ANCHOR *) ;
STATUS find_log_expr_list_elem (STORAGE_SEG_ANCHOR *,LOG_EXPR *,int,LOG_EXPR_LIST_ELEM *,LOG_EXPR_LIST_ELEM **) ;
STATUS insert_log_expr (STORAGE_SEG_ANCHOR *,LOG_EXPR *,int,int *,LOG_EXPR_LIST_ELEM **,BOOLEAN) ;
#if defined(KEEP_TRANS_INFO)
STATUS insert_trans_list(LOG_EXPR_LIST_ELEM *,int, LOG_EXPR_LIST_ELEM *) ; 
#endif
#if DEBUG>=3 && defined(PRINT)
STATUS print_log_expr_list_elem (LOG_EXPR_LIST_ELEM *, BOOLEAN) ;
#endif
#else
STATUS link_eq_classes () ;
char *error_text () ;
STATUS generate_all_transformations () ;
STATUS find_log_expr_list_elem () ;
STATUS insert_log_expr () ;
#if defined(KEEP_TRANS_INFO)
STATUS insert_trans_list() ;
#endif
#if DEBUG>=3 && defined(PRINT)
STATUS print_log_expr_list_elem () ;
#endif
#endif
extern int              opt_arity[] ;

extern TRACE            trace ;
#ifdef GET_STATS
extern int		     num_reallocs;
#endif
#if defined(__cplusplus) || defined(ANSI)
STATUS match_trans_rule(LOG_EXPR_LIST_ELEM *lele_in,
LOG_EXPR *log_expr,int rule_group,
STORAGE_SEG_ANCHOR *ssa)
#else
STATUS match_trans_rule(lele_in,log_expr,rule_group,ssa)
LOG_EXPR_LIST_ELEM	*lele_in ;
LOG_EXPR		*log_expr ;
int		rule_group ;
STORAGE_SEG_ANCHOR	*ssa ;
#endif
{
EQ_CLASS		*eq_class, *temp_eq_class ;
LOG_EXPR		temp_log_expr ;
int			ret_eq_class_index, i ;
/* BOOLEAN			insert_expr ; */ 
LOG_EXPR_LIST_ELEM	*lele[20], *ret_lele[20] ;
OPERATOR		operator_array[20];
OPERATOR_ARGUMENT	*op_argument[20];
OPERATOR_ARGUMENT	temp_op_argument[20];
LOG_EXPR_LIST_ELEM	*input[40];
BOOLEAN			found_rule ;
int			RULE_ITERATION ;
int			FIRE_RULE_COUNT ;
STATUS			error ;

get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

#if SAFETY>=1
for (i = opt_arity[(int) (log_expr->my_operator)];--i >= 0;)
{
if (!(log_expr->input[i])) continue;
get_eq_class_addr(ssa,log_expr->input[i]->eq_class_index,
&temp_eq_class) ;
if (log_expr->input[i] != temp_eq_class->log_expr_list.first)
{printi ("Problem with input.\n") ;
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
}}
#endif

#if DEBUG>=3
if (trace ==TRACE_ON) {
printi ("in match_trans_rule for list element:\n") ;
CALL(print_log_expr_list_elem(lele_in,TRUE)) ;
}
#endif

for (;;)
{

try_rule:
switch (++ (lele_in -> last_rule))
{
case (0):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_0 :
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != SELECT)
goto incr_rule_iteration_0; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_0; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_0; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
if ( op_argument[0]->select.terms == 1 )
goto incr_rule_iteration_0;;
}
{
int i;
(&(temp_op_argument[3]))->select.terms = 1;
(&(temp_op_argument[3]))->select.cond[0] = op_argument[0]->select.cond[0];
(&(temp_op_argument[4]))->select.terms = op_argument[0]->select.terms-1;
for (i=1 ; i<op_argument[0]->select.terms ; i++) {
(&(temp_op_argument[4]))->select.cond[i-1] = op_argument[0]->select.cond[i];
(&(temp_op_argument[4]))->select.op[i-1] = op_argument[0]->select.op[i];
}
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[4]));
temp_log_expr.input[0] = input[1] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[1])) ;
if (ret_lele[1] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[1], FALSE)) ;
ret_lele[1] -> rule_generated_from = 0 ;
CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[1] -> eq_class_index,&temp_eq_class);
ret_lele[1] = temp_eq_class -> log_expr_list.first;
if (ret_lele[1] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_0; 
/* FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ; */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[3]));
temp_log_expr.input[0] = ret_lele[1] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 0 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_0; 
/* FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ; */ 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,0,ret_lele[0]));
#endif
found_rule = TRUE ;
incr_rule_iteration_0: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_0 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (1):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_1 :
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != MAT)
goto incr_rule_iteration_1; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_1; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_1; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != SELECT)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
if (lele[1]->expr.input[0] == NULL)
continue;
lele[2] = lele[1] -> expr.input[0];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[2] = lele[1] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
copy_operator_arg((&(temp_op_argument[4])),op_argument[1]);
copy_operator_arg((&(temp_op_argument[5])),op_argument[0]);
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = MAT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[5]));
temp_log_expr.input[0] = input[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[1])) ;
if (ret_lele[1] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[1], FALSE)) ;
ret_lele[1] -> rule_generated_from = 1 ;
CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[1] -> eq_class_index,&temp_eq_class);
ret_lele[1] = temp_eq_class -> log_expr_list.first;
if (ret_lele[1] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[4]));
temp_log_expr.input[0] = ret_lele[1] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 1 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,1,ret_lele[0]));
#endif
found_rule = TRUE ;
}
incr_rule_iteration_1: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_1 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (2):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_2 :
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != SELECT)
goto incr_rule_iteration_2; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_2; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_2; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != MAT)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
if (lele[1]->expr.input[0] == NULL)
continue;
lele[2] = lele[1] -> expr.input[0];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[2] = lele[1] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
LOGICAL_PROPERTY    *left;
eq_class_logical_property(input[2], left);
if (! all_select_in_set(&(op_argument[0]->select), left)) 
continue;

}
{
copy_operator_arg((&(temp_op_argument[4])),op_argument[1]);
copy_operator_arg((&(temp_op_argument[5])),op_argument[0]);
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[5]));
temp_log_expr.input[0] = input[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[1])) ;
if (ret_lele[1] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[1], FALSE)) ;
ret_lele[1] -> rule_generated_from = 2 ;
CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[1] -> eq_class_index,&temp_eq_class);
ret_lele[1] = temp_eq_class -> log_expr_list.first;
if (ret_lele[1] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = MAT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[4]));
temp_log_expr.input[0] = ret_lele[1] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 2 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,2,ret_lele[0]));
#endif
found_rule = TRUE ;
}
incr_rule_iteration_2: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_2 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (3):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_3 :
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != MAT)
goto incr_rule_iteration_3; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_3; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_3; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
int i;
if ( op_argument[0]->mat.num != 1)
goto incr_rule_iteration_3;;
if ( op_argument[0]->mat.ref_or_set[0])
goto incr_rule_iteration_3;;
}
{
(&(temp_op_argument[4]))->get_set.input = op_argument[0]->mat.input[0];
strcpy((&(temp_op_argument[4]))->get_set.attr,op_argument[0]->mat.attr[0]);
(&(temp_op_argument[4]))->get_set.use_self=TRUE;
(&(temp_op_argument[3]))->join.type = OPER;
(&(temp_op_argument[3]))->join.data.op = EQUAL_OP;
(&(temp_op_argument[3]))->join.left = (JOIN_ARG*) malloc(sizeof(JOIN_ARG));
(&(temp_op_argument[3]))->join.left->type = ATTRIB;
strcpy((&(temp_op_argument[3]))->join.left->data.attr,op_argument[0]->mat.attr[0]);
if (op_argument[0]->mat.fcn[0]) {
(&(temp_op_argument[3]))->join.left->fcn = (FCN_INPUT *) malloc(sizeof(FCN_INPUT));
memcpy((&(temp_op_argument[3]))->join.left->fcn,op_argument[0]->mat.fcn[0],sizeof(FCN_INPUT));
}
else
(&(temp_op_argument[3]))->join.left->fcn = NULL;
(&(temp_op_argument[3]))->join.left->left = NULL;
(&(temp_op_argument[3]))->join.left->right = NULL;
(&(temp_op_argument[3]))->join.right = (JOIN_ARG*) malloc(sizeof(JOIN_ARG)); 
(&(temp_op_argument[3]))->join.right->type = ATTRIB; 
strcpy((&(temp_op_argument[3]))->join.right->data.attr,op_argument[0]->mat.attr[0]);
strcat((&(temp_op_argument[3]))->join.right->data.attr,".self");
(&(temp_op_argument[3]))->join.right->left = NULL;
(&(temp_op_argument[3]))->join.right->right = NULL;
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = GET_SET ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[4]));
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[2])) ;
if (ret_lele[2] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[2], FALSE)) ;
ret_lele[2] -> rule_generated_from = 3 ;
CALL (generate_all_transformations (ret_lele[2],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[2] -> eq_class_index,&temp_eq_class);
ret_lele[2] = temp_eq_class -> log_expr_list.first;
if (ret_lele[2] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_3; 
/* FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ; */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[2],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = JOIN ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[3]));
temp_log_expr.input[0] = input[1] ;
temp_log_expr.input[1] = ret_lele[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 3 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_3; 
/* FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ; */ 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,3,ret_lele[0]));
#endif
found_rule = TRUE ;
incr_rule_iteration_3: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_3 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (4):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_4 :
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != SELECT)
goto incr_rule_iteration_4; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_4; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_4; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != JOIN)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
if (lele[1]->expr.input[0] == NULL)
continue;
if (lele[1]->expr.input[1] == NULL)
continue;
lele[2] = lele[1] -> expr.input[0];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[2] = lele[1] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[3] = lele[1] -> expr.input[1];
get_eq_class_addr
(ssa,lele[3] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[3] = lele[1] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[3]->eq_class_index,
&temp_eq_class) ;
if (input[3] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
LOGICAL_PROPERTY    *right;
eq_class_logical_property(input[3], right);
if (!select_in_set(&(op_argument[0]->select), right))
continue;
}
{
/* Just copy over */
copy_operator_arg((&(temp_op_argument[5])), op_argument[1]);
copy_operator_arg((&(temp_op_argument[6])), op_argument[0]);
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[6]));
temp_log_expr.input[0] = input[3] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[2])) ;
if (ret_lele[2] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[2], FALSE)) ;
ret_lele[2] -> rule_generated_from = 4 ;
CALL (generate_all_transformations (ret_lele[2],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[2] -> eq_class_index,&temp_eq_class);
ret_lele[2] = temp_eq_class -> log_expr_list.first;
if (ret_lele[2] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[2],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = JOIN ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[5]));
temp_log_expr.input[0] = input[2] ;
temp_log_expr.input[1] = ret_lele[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 4 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,4,ret_lele[0]));
#endif
found_rule = TRUE ;
}
incr_rule_iteration_4: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_4 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (5):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_5 :
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != SELECT)
goto incr_rule_iteration_5; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_5; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_5; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != JOIN)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
if (lele[1]->expr.input[0] == NULL)
continue;
if (lele[1]->expr.input[1] == NULL)
continue;
lele[2] = lele[1] -> expr.input[0];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[2] = lele[1] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[3] = lele[1] -> expr.input[1];
get_eq_class_addr
(ssa,lele[3] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[3] = lele[1] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[3]->eq_class_index,
&temp_eq_class) ;
if (input[3] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
LOGICAL_PROPERTY    *left;

eq_class_logical_property(input[2], left);

if (!select_in_set(&(op_argument[0]->select), left))
continue;
}
{
/* Just copy over */
copy_operator_arg((&(temp_op_argument[5])), op_argument[1]);
copy_operator_arg((&(temp_op_argument[6])), op_argument[0]);
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[6]));
temp_log_expr.input[0] = input[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[1])) ;
if (ret_lele[1] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[1], FALSE)) ;
ret_lele[1] -> rule_generated_from = 5 ;
CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[1] -> eq_class_index,&temp_eq_class);
ret_lele[1] = temp_eq_class -> log_expr_list.first;
if (ret_lele[1] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = JOIN ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[5]));
temp_log_expr.input[0] = ret_lele[1] ;
temp_log_expr.input[1] = input[3] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 5 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,5,ret_lele[0]));
#endif
found_rule = TRUE ;
}
incr_rule_iteration_5: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_5 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (6):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_6 :
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != JOIN)
goto incr_rule_iteration_6; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_6; 
if (lele[0]->expr.input[1] == NULL)
goto incr_rule_iteration_6; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_6; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != SELECT)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
if (lele[1]->expr.input[0] == NULL)
continue;
lele[3] = lele[1] -> expr.input[0];
get_eq_class_addr
(ssa,lele[3] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[3] = lele[1] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[3]->eq_class_index,
&temp_eq_class) ;
if (input[3] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[2] = lele[0] -> expr.input[1];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[2] = lele[0] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
/* Just copy over */
copy_operator_arg((&(temp_op_argument[5])), op_argument[1]);
copy_operator_arg((&(temp_op_argument[6])), op_argument[0]);
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = JOIN ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[6]));
temp_log_expr.input[0] = input[3] ;
temp_log_expr.input[1] = input[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[1])) ;
if (ret_lele[1] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[1], FALSE)) ;
ret_lele[1] -> rule_generated_from = 6 ;
CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[1] -> eq_class_index,&temp_eq_class);
ret_lele[1] = temp_eq_class -> log_expr_list.first;
if (ret_lele[1] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[5]));
temp_log_expr.input[0] = ret_lele[1] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 6 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,6,ret_lele[0]));
#endif
found_rule = TRUE ;
}
incr_rule_iteration_6: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_6 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (7):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_7 :
lele[0] = lele_in;
if (lele_in -> rule_generated_from == 7) goto try_rule ;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != JOIN)
goto incr_rule_iteration_7; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_7; 
if (lele[0]->expr.input[1] == NULL)
goto incr_rule_iteration_7; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_7; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[2] = lele[0] -> expr.input[1];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_7; 
input[2] = lele[0] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
if (op_argument[0]->join.type==OPER && op_argument[0]->join.data.op ==AND_OP)
goto incr_rule_iteration_7;;
}
{
/* Reverse the join argument */
(&(temp_op_argument[4]))->join.left  = op_argument[0]->join.right;
(&(temp_op_argument[4]))->join.right = op_argument[0]->join.left;
(&(temp_op_argument[4]))->join.type = OPER;
switch (op_argument[0]->join.data.op)
{
case EQUAL_OP: (&(temp_op_argument[4]))->join.data.op = EQUAL_OP; break;
case LESS_THAN_OP: (&(temp_op_argument[4]))->join.data.op = GREATER_THAN_OP; break;
case GREATER_THAN_OP: (&(temp_op_argument[4]))->join.data.op = LESS_THAN_OP; break;
case LESS_THAN_EQUAL_OP: (&(temp_op_argument[4]))->join.data.op = GREATER_THAN_EQUAL_OP; break;
case GREATER_THAN_EQUAL_OP: (&(temp_op_argument[4]))->join.data.op = LESS_THAN_EQUAL_OP; break;
case NOT_EQUAL_OP: (&(temp_op_argument[4]))->join.data.op = NOT_EQUAL_OP; break;
} /* switch */
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = JOIN ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[4]));
temp_log_expr.input[0] = input[2] ;
temp_log_expr.input[1] = input[1] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 7 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_7; 
/* FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ; */ 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,7,ret_lele[0]));
#endif
found_rule = TRUE ;
incr_rule_iteration_7: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_7 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (8):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_8 :
lele[0] = lele_in;
if (lele_in -> rule_generated_from == 8) goto try_rule ;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != SELECT)
goto incr_rule_iteration_8; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_8; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_8; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != SELECT)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
if (lele[1]->expr.input[0] == NULL)
continue;
lele[2] = lele[1] -> expr.input[0];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[2] = lele[1] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
/* Just copy over */
copy_operator_arg((&(temp_op_argument[4])), op_argument[1]);
copy_operator_arg((&(temp_op_argument[5])), op_argument[0]);
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[5]));
temp_log_expr.input[0] = input[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[1])) ;
if (ret_lele[1] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[1], FALSE)) ;
ret_lele[1] -> rule_generated_from = 8 ;
CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[1] -> eq_class_index,&temp_eq_class);
ret_lele[1] = temp_eq_class -> log_expr_list.first;
if (ret_lele[1] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[4]));
temp_log_expr.input[0] = ret_lele[1] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 8 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,8,ret_lele[0]));
#endif
found_rule = TRUE ;
}
incr_rule_iteration_8: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_8 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (9):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_9 :
lele[0] = lele_in;
if (lele_in -> rule_generated_from == 9) goto try_rule ;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != MAT)
goto incr_rule_iteration_9; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_9; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_9; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != MAT)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
if (lele[1]->expr.input[0] == NULL)
continue;
lele[2] = lele[1] -> expr.input[0];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[2] = lele[1] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
int i,j;
if ((op_argument[0]->mat.num != 1) || (op_argument[1]->mat.num!=1))
continue;
i = strlen(op_argument[0]->mat.attr[0]);
j = strlen(op_argument[1]->mat.attr[0]);
if (i < j) j =i;
if ( strncmp(op_argument[0]->mat.attr[0],op_argument[1]->mat.attr[0],j)== 0 )
continue;
}
{
/* Just copy over */
copy_operator_arg((&(temp_op_argument[4])), op_argument[1]);
copy_operator_arg((&(temp_op_argument[5])), op_argument[0]);
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = MAT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[5]));
temp_log_expr.input[0] = input[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[1])) ;
if (ret_lele[1] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[1], FALSE)) ;
ret_lele[1] -> rule_generated_from = 9 ;
CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[1] -> eq_class_index,&temp_eq_class);
ret_lele[1] = temp_eq_class -> log_expr_list.first;
if (ret_lele[1] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[1],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = MAT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[4]));
temp_log_expr.input[0] = ret_lele[1] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 9 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,9,ret_lele[0]));
#endif
found_rule = TRUE ;
}
incr_rule_iteration_9: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_9 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (10):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_10 :
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != SELECT)
goto incr_rule_iteration_10; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_10; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_10; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != SELECT)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
if (lele[1]->expr.input[0] == NULL)
continue;
lele[2] = lele[1] -> expr.input[0];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[2] = lele[1] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
/* Only handle AND conditions for now */
int i;
LOGICAL_PROPERTY    *left;
eq_class_logical_property(input[2], left);
if (! all_select_in_set(&(op_argument[0]->select), left))
continue;
if (! all_select_in_set(&(op_argument[1]->select), left))
continue;

/* Copy from operator 1 */
(&(temp_op_argument[4]))->select.terms = 0;
for (i = 0; i != op_argument[0]->select.terms; i++)
{
(&(temp_op_argument[4]))->select.op[(&(temp_op_argument[4]))->select.terms] = AND_OP;
(&(temp_op_argument[4]))->select.cond[(&(temp_op_argument[4]))->select.terms] =
op_argument[0]->select.cond[i];
(&(temp_op_argument[4]))->select.terms++;
} /* for */

/* Copy from operator 2 */
for (i = 0; i != op_argument[1]->select.terms; i++)
{
(&(temp_op_argument[4]))->select.op[(&(temp_op_argument[4]))->select.terms] = AND_OP;
(&(temp_op_argument[4]))->select.cond[(&(temp_op_argument[4]))->select.terms] =
op_argument[1]->select.cond[i];
(&(temp_op_argument[4]))->select.terms++;
} /* for */
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = SELECT ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[4]));
temp_log_expr.input[0] = input[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 10 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,10,ret_lele[0]));
#endif
found_rule = TRUE ;
}
incr_rule_iteration_10: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_10 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (11):
found_rule = FALSE ;
FIRE_RULE_COUNT = 1 ;
RULE_ITERATION = 1 ;
fire_rule_11 :
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != JOIN)
goto incr_rule_iteration_11; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto incr_rule_iteration_11; 
if (lele[0]->expr.input[1] == NULL)
goto incr_rule_iteration_11; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto incr_rule_iteration_11; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != JOIN)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
if (lele[1]->expr.input[0] == NULL)
continue;
if (lele[1]->expr.input[1] == NULL)
continue;
lele[3] = lele[1] -> expr.input[0];
get_eq_class_addr
(ssa,lele[3] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[3] = lele[1] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[3]->eq_class_index,
&temp_eq_class) ;
if (input[3] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[4] = lele[1] -> expr.input[1];
get_eq_class_addr
(ssa,lele[4] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[4] = lele[1] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[4]->eq_class_index,
&temp_eq_class) ;
if (input[4] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[2] = lele[0] -> expr.input[1];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
input[2] = lele[0] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
LOGICAL_PROPERTY   *left;
JOIN_ARG           *ja;

eq_class_logical_property(input[4], left);
if ( op_argument[0]->join.data.op == AND_OP)
ja= Find_Join_Arg((JOIN_ARG*)(op_argument[0]->join.left->left));
else
	ja = Find_Join_Arg((JOIN_ARG*)(op_argument[0]->join.left));
if ( ! attr_in_set(ja->data.attr,left)) continue;
}
{
/* copy the operator arguments to the newly generated expression */
copy_operator_arg((&(temp_op_argument[6])), op_argument[1]);
copy_operator_arg((&(temp_op_argument[7])), op_argument[0]);
}
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = JOIN ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[7]));
temp_log_expr.input[0] = input[4] ;
temp_log_expr.input[1] = input[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[2])) ;
if (ret_lele[2] == NULL)
{
CALL (insert_log_expr (ssa, &temp_log_expr,
(int) -1, &ret_eq_class_index, 
&ret_lele[2], FALSE)) ;
ret_lele[2] -> rule_generated_from = 11 ;
CALL (generate_all_transformations (ret_lele[2],
rule_group, ssa)) ;
} 
else {
get_eq_class_addr(ssa,ret_lele[2] -> eq_class_index,&temp_eq_class);
ret_lele[2] = temp_eq_class -> log_expr_list.first;
if (ret_lele[2] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{
 CALL (generate_all_transformations (ret_lele[2],
rule_group, ssa)) ;
}
} 
 } 
init_log_expr(&temp_log_expr);
temp_log_expr.my_operator = JOIN ;
/* insert_expr = TRUE ; */ 
copy_operator_arg(&(temp_log_expr.argument),&(temp_op_argument[6]));
temp_log_expr.input[0] = input[3] ;
temp_log_expr.input[1] = ret_lele[2] ;
CALL (find_log_expr_list_elem (ssa, &temp_log_expr, (int) -1,
(LOG_EXPR_LIST_ELEM *) NULL, &ret_lele[0])) ;
if (ret_lele[0] == NULL)
{
get_eq_class_addr(ssa,lele_in->eq_class_index,&eq_class) ;

CALL (insert_log_expr (ssa, &temp_log_expr,
eq_class->eq_class_index, &ret_eq_class_index, 
&ret_lele[0], FALSE)) ;
ret_lele[0] -> rule_generated_from = 11 ;
} 
else {
get_eq_class_addr(ssa,ret_lele[0] -> eq_class_index,&temp_eq_class);
ret_lele[0] = temp_eq_class -> log_expr_list.first;
if (ret_lele[0] -> eq_class_index != lele[0] -> eq_class_index)
{
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
continue; 
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE ||
    temp_eq_class -> trans_flag == NO_TRANSFORMATIONS)
{ 
CALL (link_eq_classes (ssa, lele[0] -> eq_class_index, 
temp_eq_class -> eq_class_index)) ;}
} 
 } 
#ifdef KEEP_TRANS_INFO
CALL (insert_trans_list(lele_in,11,ret_lele[0]));
#endif
found_rule = TRUE ;
}
incr_rule_iteration_11: 
++ RULE_ITERATION ;
if (RULE_ITERATION <= FIRE_RULE_COUNT)
goto fire_rule_11 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
default:lele_in->last_rule = NO_MORE;return (OKAY);
}
}
}
